
'-------------------------------------------------------------------------------
'Cleaned-up version of the MCS Bootloader
'-------------------------------------------------------------------------------

'http://www.mcselec.com/index2.php?option=com_forum&Itemid=59&page=viewtopic&t=7357&highlight=cleanedup+mcs+bootloader


'-------------------------------------------------------------------------------
'Set the Lock and Fuse bits as you like, do not use this values after $prog
'Choose "Bootsize 1024 words" and "Reset vector is bootloader"
'Set the $crystal, $baud and $timeout as you like.
'-------------------------------------------------------------------------------

$crystal = 8000000                                          '8MHz

'$crystal = 16000000                                         '16MHz

$baud = 38400                                               '38400
$baud1 = 38400                                              '38400
$timeout = 800000                                           'usual timeout = 400000 with 16MHz


$prog &HFF , &H7F , &HD2 , &HFF                             ' generated. Take care that the chip supports all fuse bytes.

$regfile = "m128def.dat"
'$loader = $fc00                                                                 '1024Byte                                                               'sets the bootsize to 1024 words under flash size
$loader = $f800                                             '2048Byte
'$loader = $f000                                                                 '4096Byte

Const Pagemsb = 7                                           '128 words in a page reguires 7 bits


'Open "Com1:" For Binary As #1
Open "Com2:" For Binary As #1

Dim Retries As Byte
Dim Receivedbyte As Byte
Dim Kindofdata As Byte
Dim Spmcsrvalue As Byte
Dim Calculatedchecksum As Byte
Dim Receivedblock As Byte
Dim Countedblock As Byte
Dim Invertedblock As Byte
Dim Receivedchecksum As Byte
Dim Receivedbytes(128) As Byte
Dim J As Byte
Dim Vl As Byte
Dim Vh As Byte
Dim Wrd As Word
Dim Page As Word
Dim Z As Long

'-------------------------------------------------------------------------------
'Esf
Const Flashtobuf1transfer = &H53                            ' Main Memory Page To Buffer 1 Transfer
Const Buf1read = &HD4                                       ' Buffer 1 Read
Const Statusreg = &HD7                                      '&H57                                                          ' Status Register
Const Buf1write = &H84                                      ' Buffer 1 Write
Const Buf1toflash = &H88                                    ' Buffer 1 To Main Memory Page Program Without Built -in Erase
Const Buf1toflashwe = &H83                                  ' Buffer 1 To Main Memory Page Program With Built -in Erase

Dim Status_register_value As Byte
Dim Pagecounter As Word
Dim Esfsystemsize As Long
Dim Esfsystemcount As Long
Dim Esfblockcount As Word
Dim Esf_valid_system As Byte
Dim B_bb As Byte
Dim W_ww As Word

Declare Function Df_read_status()as Byte
Declare Sub Df_init()
Declare Function Df_bufferreadbyte(byval Intpageadr As Word) As Byte
Declare Sub Df_bufferwritebyte(byval Intpageadr As Word , Byval Databyte As Byte)
Declare Sub Df_pagetobuffer(byval Pageadr As Word)
Declare Sub Df_buffertopage(byval Pageadr As Word)


Print #1 , "Dual Bootloader by six1"

   Led1 Alias Portg.3
   Config Led1 = Output

   Config Ping.4 = Output                                   ' define here Pin for CS External serial Flash
   Esf_cs Alias Portg.4
   Config Esf_cs = Output
   Set Esf_cs

   Config Pinb.0 = Output                                   ' define here Pin for CS External serial Flash
   Tc77_cs Alias Portb.0
   Config Tc77_cs = Output
   Set Tc77_cs

   Config Pinf.7 = Output                                   ' define here Pin for CS External serial Flash
   Mmc_cs Alias Portf.7
   Config Mmc_cs = Output
   Set Mmc_cs

   Call Df_init()

   'Check, if valid System in ESF
   Call Df_pagetobuffer(2047)
   Esf_valid_system = Df_bufferreadbyte(0 )
'   Print #1 , "ESF valid : " ; Esf_valid_system


'get 256Bytes Blockcount
If Esf_valid_system = 1 Then
   B_bb = Df_bufferreadbyte(1)
   Esfblockcount = B_bb
   Shift Esfblockcount , Left , 8
   B_bb = Df_bufferreadbyte(2)
   Esfblockcount = Esfblockcount + B_bb
'   Print #1 , "ESF Bootloader  BlockCount: " ; Esfblockcount
   Led1 = 0
Else
'   Print #1 , "ESF Bootloader..."
   Esf_valid_system = 0
   Led1 = 1
End If



Disable Interrupts

Const Maxword =(2 ^ Pagemsb) * 2
Const Zpagemsb = Pagemsb + 1
Const Soh = &H01
Const Stx = &H02
Const Eot = &H04
Const Ack = &H06
Const Nak = &H15
Const Can = &H18

If Esf_valid_system = 0 Then
'   Print #1 , "Serial Bootloader..."
   Retries = 5
 Testformagicbyte:
   Toggle Led1
   Receivedbyte = Waitkey(#1)
   Print #1 , Chr(receivedbyte);
   If Receivedbyte = 123 Then
     Kindofdata = 0
     Goto Loader
   Elseif Receivedbyte = 124 Then
     Kindofdata = 1
     Goto Loader
   Elseif Receivedbyte <> 0 Then
     Decr Retries
     If Retries <> 0 Then Goto Testformagicbyte
   End If
   Goto _reset

   Loader:
   Do
      Receivedbyte = Waitkey(#1)
   Loop Until Receivedbyte = 0

   If Kindofdata = 0 Then
     Spmcsrvalue = 3 : Gosub Do_spm
     Spmcsrvalue = 17 : Gosub Do_spm
   End If
   Retries = 10
End If

Do

If Esf_valid_system = 0 Then
  Calculatedchecksum = 0
  Print #1 , Chr(nak);
  Do
    Toggle Led1
    Receivedbyte = Waitkey(#1)
    Select Case Receivedbyte
    Case &H01:                                              '<SOH>
      Incr Countedblock
      Calculatedchecksum = 1
      Receivedblock = Waitkey(#1)
      Calculatedchecksum = Calculatedchecksum + Receivedblock
      Invertedblock = Waitkey(#1)
      Calculatedchecksum = Calculatedchecksum + Invertedblock
      For J = 1 To 128
        Receivedbytes(j) = Waitkey(#1)
        Calculatedchecksum = Calculatedchecksum + Receivedbytes(j)
      Next
      Receivedchecksum = Waitkey(#1)
      If Countedblock = Receivedblock Then
        If Receivedchecksum = Calculatedchecksum Then
          Gosub Writepage
          Print #1 , Chr(ack);
        Else
          Print #1 , Chr(nak);
        End If
      Else
        Print #1 , Chr(nak);
      End If
    Case &H04:                                              '<EOT>
      If Wrd > 0 And Kindofdata = 0 Then
        Wrd = 0
        Spmcsrvalue = 5 : Gosub Do_spm
        Spmcsrvalue = 17 : Gosub Do_spm
      End If
      Print #1 , Chr(ack);
      Waitms 20
      Set Led1
      Goto _reset
    Case &H18:                                              '<CAN>
      Set Led1
      Goto _reset
    Case Else
      Exit Do
    End Select
  Loop

  If Retries > 0 Then
    Waitms 1000
    Decr Retries
  Else
    Set Led1
    Goto 0
  End If
Else
   Kindofdata = 0
   Wrd = 0
   Spmcsrvalue = 3 : Gosub Do_spm
   Spmcsrvalue = 17 : Gosub Do_spm

   'flash
   For Pagecounter = 0 To Esfblockcount
      ' catch Page
      Call Df_pagetobuffer(pagecounter)
      For W_ww = 0 To 127
         Receivedbytes(w_ww + 1) = Df_bufferreadbyte(w_ww )
      Next
      Gosub Writepage
      For W_ww = 128 To 255
         Receivedbytes(w_ww - 127) = Df_bufferreadbyte(w_ww )
      Next
      Gosub Writepage
      'Print #1 , "Flash Block: " ; Pagecounter
      Toggle Led1
   Next

   Wrd = 0
   Spmcsrvalue = 5 : Gosub Do_spm
   Spmcsrvalue = 17 : Gosub Do_spm

  ' System in ESF is obsolet
   Call Df_bufferwritebyte(0 , 0)
   Call Df_buffertopage(2047)
   'Print #1 , "End Flash"
   Set Led1
   Goto _reset
End If

Loop

Writepage:
If Kindofdata = 0 Then
  For J = 1 To 128 Step 2
    Vl = Receivedbytes(j)
    Vh = Receivedbytes(j + 1)
    lds r0, {vl}
    lds r1, {vh}
    Spmcsrvalue = 1 : Gosub Do_spm
    Wrd = Wrd + 2
    If Wrd = Maxword Then
      Wrd = 0
      Spmcsrvalue = 5 : Gosub Do_spm
      Spmcsrvalue = 17 : Gosub Do_spm
      Page = Page + 1
      Spmcsrvalue = 3 : Gosub Do_spm
      Spmcsrvalue = 17 : Gosub Do_spm
    End If
  Next
Else
  For J = 1 To 128
    Writeeeprom Receivedbytes(j) , Wrd
    Wrd = Wrd + 1
  Next
End If
Return

Do_spm:
  Bitwait Spmcsr.0 , Reset
  Bitwait Eecr.1 , Reset
  Z = Page
  Shift Z , Left , Zpagemsb
  Z = Z + Wrd
  lds r30, {Z}
  lds r31, {Z + 1}
  #if _romsize > 65536
    lds r24, {Z + 2}
    sts rampz, r24
  #endif
  Spmcsr = Spmcsrvalue
  spm
  nop
  nop
Return


Sub Df_init()
   Config Spi = Hard , Interrupt = Off , Data Order = Msb , Master = Yes , Polarity = Low , Phase = 0 , Clockrate = 4 , Noss = 1 , Spiin = 0
   Set Spsr.spi2x
   Spiinit
   Status_register_value = Df_read_status()
End Sub


Function Df_read_status() As Byte
   Local B_b As Byte
   Reset Esf_cs
   B_b = Statusreg
   Spiout B_b , 1                                           ' Send Status Register Read Op -code
   Spiin Df_read_status , 1                                 ' Send Status Register Read Op -code
   B_b = 0
   Spiout B_b , 1                                           ' Dummy Write To Get Result
   Spiin Df_read_status , 1                                 ' Dummy Write To Get Result
   Set Esf_cs
End Function


Sub Df_pagetobuffer(byval Pageadr As Word)
   Local B_b As Byte , B_c As Byte

   Reset Esf_cs
   B_b = Flashtobuf1transfer
   Spiout B_b , 1
   B_c = High(pageadr)
   Spiout B_c , 1                                           ' Dummy Write To Get Result

   B_c = Low(pageadr)
   Spiout B_c , 1

   B_b = 0
   Spiout B_b , 1                                           ' Dummy Write
   Set Esf_cs
   Reset Esf_cs

   Do
     B_b = Df_read_status()
   Loop Until B_b.7 = 1

   Reset Esf_cs
End Sub



Sub Df_buffertopage(byval Pageadr As Word)
   Local B_b As Byte , B_c As Byte

   Reset Esf_cs
   B_b = Buf1toflashwe
   Spiout B_b , 1

   B_c = High(pageadr)
   Spiout B_c , 1                                           ' Dummy Write To Get Result

   B_c = Low(pageadr)
   Spiout B_c , 1

   B_b = 0
   Spiout B_b , 1                                           ' Dummy Write
   Set Esf_cs
   Reset Esf_cs

   Do
     B_b = Df_read_status()
   Loop Until B_b.7 = 1

   Reset Esf_cs
End Sub


Function Df_bufferreadbyte(byval Intpageadr As Word) As Byte
   Local B_b As Byte

   Reset Esf_cs
   B_b = Buf1read
   Spiout B_b , 1

   B_b = 0
   Spiout B_b , 1
   B_b = High(intpageadr)                                   ' Don't cares
   Spiout B_b , 1                                           ' Upper Part Of Internal Buffer Address
   B_b = Low(intpageadr)
   Spiout B_b , 1                                           ' Lower Part Of Internal Buffer Address
   B_b = 0
   Spiout B_b , 1
   Spiin Df_bufferreadbyte , 1                              ' Read Byte
   Set Esf_cs
End Function


Sub Df_bufferwritebyte(byval Intpageadr As Word , Byval Databyte As Byte)
   Local B_b As Byte

   Reset Esf_cs
   B_b = Buf1write
   Spiout B_b , 1

   B_b = 0
   Spiout B_b , 1
   B_b = High(intpageadr)                                   ' Don't cares
   Spiout B_b , 1                                           ' Upper Part Of Internal Buffer Address
   B_b = Low(intpageadr)
   Spiout B_b , 1                                           ' Lower Part Of Internal Buffer Address
   Spiout Databyte , 1
   Set Esf_cs
End Sub







'How to use this program:
'1- compile this program
'2- program into chip
'3- select MCS Bootloader from programmers
'4- compile a new program
'5- press F4 and reset your micro
'the program will be uploaded into the chip

'How to call the bootloader from your program without a reset ???
'  Goto &H1C00
'The GOTO will do the work, you need to specify the correct bootloader address
'this is the same as the $LOADER statement.