'*******************************************************************************
'
'  Copyright Michael Koecher aka six1 8/2010
'  -> http://www.six1.net/   michael@koecher-web.de
'
'   http://creativecommons.org/licenses/by-sa/3.0/de/
'
'   Sie drfen:
'
'     * das Werk bzw. den Inhalt vervielfltigen, verbreiten und ffentlich zugnglich machen
'
'     * Abwandlungen und Bearbeitungen des Werkes bzw. Inhaltes anfertigen
'
'   Zu Den Folgenden Bedingungen:
'
'     * Namensnennung.
'       Sie mssen den Namen des Autors/Rechteinhabers in der von ihm festgelegten Weise nennen.
'
'     * Keine kommerzielle Nutzung.
'       Dieses Werk darf nicht fr kommerzielle Zwecke verwendet werden.
'
'     * Weitergabe unter gleichen Bedingungen.
'       Wenn Sie das lizenzierte Werk bzw. den lizenzierten Inhalt bearbeiten
'       oder in anderer Weise erkennbar als Grundlage fr eigenes Schaffen verwenden,
'       drfen Sie die daraufhin neu entstandenen Werke bzw. Inhalte nur
'       unter Verwendung von Lizenzbedingungen weitergeben, die mit denen
'       dieses Lizenzvertrages identisch oder vergleichbar sind.
'
'   Wobei gilt:
'
'     * Verzichtserklrung
'       Jede der vorgenannten Bedingungen kann aufgehoben werden, sofern Sie
'       die ausdrckliche Einwilligung des Rechteinhabers dazu erhalten.
'
'     * Sonstige Rechte
'       Die Lizenz hat keinerlei Einfluss auf die folgenden Rechte:
'          - Die gesetzlichen Schranken des Urheberrechts und sonstigen
'            Befugnisse zur privaten Nutzung
'          - Das Urheberpersnlichkeitsrecht des Rechteinhabers
'          - Rechte anderer Personen, entweder am Lizenzgegenstand selber oder
'            bezglich seiner Verwendung, zum Beispiel Persnlichkeitsrechte abgebildeter Personen.
'
'  Hinweis
'
'      Im Falle einer Verbreitung mssen Sie anderen alle Lizenzbedingungen
'      mitteilen, die fr dieses Werk gelten. Am einfachsten ist es,
'      einen Link auf http://creativecommons.org/licenses/by-sa/3.0/de/ einzubinden.
'

'*******************************************************************************
$nocompile


 'Look -up Table For These Sizes - > 512k , 1m , 2m , 4m , 8m , 16m , 32m , 64m
Df_pagebits_data:
 Data 9 , 9 , 9 , 9 , 9 , 10 , 10 , 11

 'Look -up Table For These Sizes - > 512k , 1m , 2m , 4m , 8m , 16m , 32m , 64m
Df_pagesize_data:
 Data 264% , 264% , 264% , 264% , 264% , 528% , 528% , 1056%


Sub Df_init()
   Local B_b As Byte
   Local Index_copy As Byte
   Local Res_byte As Byte

   Call Deactivate_all_spi_units
   Config Spi = Hard , Interrupt = Off , Data Order = Msb , Master = Yes , Polarity = Low , Phase = 0 , Clockrate = 4 , Noss = 1 , Spiin = 0       '    Config Spi = Hard , Interrupt = Off , Data Order = Msb , Master = Yes , Polarity = High , Phase = 1 , Clockrate = 4 , Noss = 1 , Spiin = 0
   Set Spsr.spi2x
   Spiinit


'256 Byte Mode
   Reset Esf_cs
   B_b = &H3D
   Spiout B_b , 1
   B_b = &H2A
   Spiout B_b , 1
   B_b = &H80
   Spiout B_b , 1
   B_b = &HA6
   Spiout B_b , 1
   'with special Thanks to Erwin who find out, that the 4ms delay is missing!
   Waitms 4
'Power cycle the device...
   Set Esf_cs


   Call Deactivate_all_spi_units
   Status_register_value = Df_read_status()

   Index_copy = Df_read_status() And &H38                   ' Get The Size Info From Status Register
   Shift Index_copy , Right , 3
'Print #1 , "Status: " ; Index_copy
   Decr Index_copy
   Pagesize = Lookup(index_copy , Df_pagesize_data)
   Pagebits = Lookup(index_copy , Df_pagebits_data)
'Print #1 , "Pagebits: " ; Pagebits
'Print #1 , "Pagesize: " ; Pagesize

'Erase sector protect

   Reset Esf_cs
   B_b = &H3D
   Spiout B_b , 1
   B_b = &H2A
   Spiout B_b , 1
   B_b = &H7F
   Spiout B_b , 1
   B_b = &HCF
   Spiout B_b , 1

   B_b = 0
   Spiout B_b , 1
   Spiout B_b , 1
   Spiout B_b , 1
   Spiout B_b , 1
   Spiout B_b , 1
   Spiout B_b , 1
   Spiout B_b , 1
   Spiout B_b , 1
   Set Esf_cs


End Sub

Sub Df_chip_erase()
   Local B_b As Byte
   Call Activate_esf
   B_b = &HC7
   Spiout B_b , 1
   B_b = &H94
   Spiout B_b , 1
   B_b = &H80
   Spiout B_b , 1
   B_b = &H9A
   Spiout B_b , 1
   Set Esf_cs
End Sub

Function Df_bufferreadbyte(byval Bufferno As Byte , Byval Intpageadr As Word) As Byte
   Local B_b As Byte

   Call Activate_esf
   If Bufferno = 1 Then                                     ' Read Byte From Buffer 1
      B_b = Buf1read
   Else
      B_b = Buf2read
   End If
   Spiout B_b , 1                                           ' Buffer 1 Read Op -code

   B_b = 0
   Spiout B_b , 1
   B_b = High(intpageadr)                                   ' Don't cares
   Spiout B_b , 1                                           ' Upper Part Of Internal Buffer Address
   B_b = Low(intpageadr)
   Spiout B_b , 1                                           ' Lower Part Of Internal Buffer Address
   B_b = 0
   Spiout B_b , 1
   Spiin Df_bufferreadbyte , 1                              ' Read Byte
   Set Esf_cs
End Function


Sub Df_bufferwritebyte(byval Bufferno As Byte , Byval Intpageadr As Word , Byval Databyte As Byte)
   Local B_b As Byte

   Call Activate_esf
   If Bufferno = 1 Then                                     ' write Byte to Buffer 1
      B_b = Buf1write
   Else
      B_b = Buf2write                                       ' write Byte to Buffer 2
   End If
   Spiout B_b , 1

   B_b = 0
   Spiout B_b , 1
   B_b = High(intpageadr)                                   ' Don't cares
   Spiout B_b , 1                                           ' Upper Part Of Internal Buffer Address
   B_b = Low(intpageadr)
   Spiout B_b , 1                                           ' Lower Part Of Internal Buffer Address
   Spiout Databyte , 1
   Set Esf_cs
End Sub



'--------------------------------------------------------------------------------
' Function name : df_read_status
'
' Returns :  One status byte. Consult Dataflash datasheet for further decoding info
'
' Parameters : None
'
' Purpose :  Status info concerning the Dataflash is busy or not.
'            Status info concerning compare between buffer and flash page
'            Status info concerning size of actual device
'
'Table 11-1. Status Register Format
'Bit 7 Bit 6 Bit 5 Bit 4 Bit 3 Bit 2 Bit 1 Bit 0
'RDY/BUSY COMP 0 1 1 1 PROTECT PAGE SIZE
'--------------------------------------------------------------------------------
Function Df_read_status() As Byte
   Local B_b As Byte

   Call Activate_esf
   B_b = Statusreg
   Spiout B_b , 1                                           ' Send Status Register Read Op -code
   Spiin Df_read_status , 1                                 ' Send Status Register Read Op -code
   B_b = 0
   Spiout B_b , 1                                           ' Dummy Write To Get Result
   Spiin Df_read_status , 1                                 ' Dummy Write To Get Result


   Set Esf_cs
End Function


'--------------------------------------------------------------------------------
'
' Function name : DF_PageToBuffer
'
' Returns :  None
'
' Parameters : BufferNo -> Decides usage of either buffer 1 or 2
'     PageAdr  -> Address of page to be transferred to buffer
'
' Purpose :  Transfers a page from flash to dataflash SRAM buffer
'
'--------------------------------------------------------------------------------
Sub Df_pagetobuffer(byval Bufferno As Byte , Byval Pageadr As Word)
   Local B_b As Byte , B_c As Byte

   Call Activate_esf

   If Bufferno = 1 Then
      B_b = Flashtobuf1transfer
   Else
      B_b = Flashtobuf2transfer
   End If
   Spiout B_b , 1
   B_c = High(pageadr)
   Spiout B_c , 1                                           ' Dummy Write To Get Result

   B_c = Low(pageadr)
   Spiout B_c , 1

   B_b = 0
   Spiout B_b , 1                                           ' Dummy Write
   Set Esf_cs
   Reset Esf_cs

   Do
     B_b = Df_read_status()
   Loop Until B_b.7 = 1

   Reset Esf_cs
End Sub



Sub Df_buffertopage(byval Bufferno As Byte , Byval Pageadr As Word)
   Local B_b As Byte , B_c As Byte

   Call Activate_esf

   If Bufferno = 1 Then
      B_b = Buf1toflashwe
   Else
      B_b = Buf2toflashwe
   End If
   Spiout B_b , 1

   B_c = High(pageadr)
   Spiout B_c , 1                                           ' Dummy Write To Get Result

   B_c = Low(pageadr)
   Spiout B_c , 1

   B_b = 0
   Spiout B_b , 1                                           ' Dummy Write
   Set Esf_cs
   Reset Esf_cs

   Do
     B_b = Df_read_status()
   Loop Until B_b.7 = 1

   Reset Esf_cs
End Sub

'--------------------------------------------------------------------------------
'
' Function name : DF_BufferReadArray
'
' Returns :  None
'
' Parameters : BufferNo -> Decides usage of either buffer 1 or 2
'     IntPageAdr -> Internal page address
'     No_of_bytes -> Number of bytes to be read
'     *BufferPtr -> address of buffer to be used for read bytes
'
' Purpose :  Reads one or more bytes from one of the dataflash
'     internal SRAM buffers, and puts read bytes into
'     buffer pointed to by *BufferPtr
'
'--------------------------------------------------------------------------------
Sub Df_bufferreadarray(byval Bufferno As Byte , Byval Intpageadr As Word , Byval No_of_bytes As Word , Byref Bufferptr As Word)
   Local B_b As Byte

   Call Activate_esf
   If Bufferno = 1 Then                                     ' Read Byte From Buffer 1
      B_b = Buf1read                                        ' Buffer 1 Read Op -code
   Else
      B_b = Buf2read                                        ' Buffer 2 Read Op -code
   End If
   Spiout B_b , 1                                           ' Buffer 1 Read Op -code
   B_b = 0
   Spiout B_b , 1
   B_b = High(intpageadr)                                   ' Don't cares
   Spiout B_b , 1                                           ' Upper Part Of Internal Buffer Address
   B_b = Low(intpageadr)                                    ' Don't cares
   Spiout B_b , 1                                           ' Lower Part Of Internal Buffer Address


   Spiin Bufferptr , No_of_bytes

   Set Esf_cs
End Sub




'--------------------------------------------------------------------------------
'
' Function name : DF_BufferWriteEnable
'
' Returns :  None
'
' Parameters : IntPageAdr -> Internal page address to start writing from
'     BufferAdr -> Decides usage of either buffer 1 or 2
'
' Purpose :  Enables continous write functionality to one of the dataflash buffers
'     buffers. NOTE : User must ensure that CS goes high to terminate
'     this mode before accessing other dataflash functionalities
'
'--------------------------------------------------------------------------------
Sub Df_bufferwriteenable(byval Bufferno As Byte , Byval Intpageadr As Word)
   Local B_b As Byte

   Call Activate_esf
   If Bufferno = 1 Then                                     ' Read Byte From Buffer 1
      B_b = Buf1write                                       ' Buffer 1 Read Op -code
   Else
      B_b = Buf2write                                       ' Buffer 2 Read Op -code
   End If
   Spiout B_b , 1                                           ' Buffer 1 Read Op -code

   B_b = 0
   Spiout B_b , 1                                           ' Don't cares
   B_b = High(intpageadr)
   Spiout B_b , 1                                           ' Upper Part Of Internal Buffer Address
   B_b = Low(intpageadr)
   Spiout B_b , 1                                           ' Lower Part Of Internal Buffer Address
   Set Esf_cs
End Sub


'--------------------------------------------------------------------------------
'
' Function name : DF_BufferWriteStr
'
' Returns :  None
'
' Parameters : BufferNo -> Decides usage of either buffer 1 or 2
'     IntPageAdr -> Internal page address
'     No_of_bytes -> Number of bytes to be written
'     *BufferPtr -> address of buffer to be used for copy of bytes
'         from AVR buffer to dataflash buffer 1 (or 2)
'
' Purpose :  Copies one or more bytes to one of the dataflash
'     internal SRAM buffers from AVR SRAM buffer
'     pointed to by *BufferPtr
'
'--------------------------------------------------------------------------------
Sub Df_bufferwritestr(byval Bufferno As Byte , Byval Intpageadr As Word , Byval No_of_bytes As Word , Byref Bufferptr As Word)
   Local B_b As Byte

   Call Activate_esf
   If Bufferno = 1 Then                                     ' Read Byte From Buffer 1
      B_b = Buf1read                                        ' Buffer 1 Read Op -code
   Else
      B_b = Buf2read                                        ' Buffer 2 Read Op -code
   End If
   Spiout B_b , 1                                           ' Buffer 1 Read Op -code

   B_b = 0
   Spiout B_b , 1                                           ' Don't cares
   B_b = High(intpageadr)
   Spiout B_b , 1                                           ' Upper Part Of Internal Buffer Address
   B_b = Low(intpageadr)
   Spiout B_b , 1                                           ' Lower Part Of Internal Buffer Address

   Spiout Bufferptr() , No_of_bytes

   Set Esf_cs
End Sub



'--------------------------------------------------------------------------------
'
' Function name : Cont_Flash_Read_Enable
'
' Returns :  None
'
' Parameters : PageAdr  -> Address of flash page where cont.read starts from
'     IntPageAdr -> Internal page address where cont.read starts from
'
' Purpose :  Initiates a continuous read from a location in the DataFlash
'
'--------------------------------------------------------------------------------
Sub Cont_flash_read_enable(byval Pageadr As Word , Byval Intpageadr As Word)
   Local B_b As Byte , W_w As Word

   Call Activate_esf

   B_b = Contarrayread
   Spiout B_b , 1
   W_w = Pageadr                                            ' Upper Part Of Page Address
   B_b = 16 - Pagebits
   Shift W_w , Right , B_b
   Spiout W_w , 1                                           ' Dummy Write To Get Result

   W_w = Pageadr                                            ' Lower Part Of Page Address
   B_b = Pagebits - 8
   Shift W_w , Left , B_b
   Spiout W_w , 1

   B_b = 0
   Spiout B_b , 1                                           ' Perform 4 Dummy Writes
   Spiout B_b , 1                                           ' In Order To Intiate Dataflash
   Spiout B_b , 1                                           ' Address Pointers
   Spiout B_b , 1
   Set Esf_cs
End Sub

'-------------------------------------------------------------------------------
'  ESF_filelist  show filelist in ESF
'-------------------------------------------------------------------------------
Sub Esf_filelist()
' Structure of Filetable:
' 1 Byte length filename|filename|3 Byte size|3 Bytes Startpos|
' $00 <-- end of filetable
   Local Filesize As Dword , Filepos As Dword , Filname As String * 30 , Filenamelen As Byte
   Local Page As Word , Pagepos As Word , Count_pos As Dword
   Local Rx_byte As Byte , X As Word , Ready As Byte , Valid_files As Byte

   Count_pos = 0
   Pagepos = 1
   Ready = 0

   Page = 513
   Call Df_pagetobuffer(1 , Page)

   Valid_files = Df_bufferreadbyte(1 , 0)
   If Valid_files = &H5A Then
    Do
     Filenamelen = Df_bufferreadbyte(1 , Pagepos)
     If Filenamelen = 0 Then
        Ready = 1
     End If
     Incr Pagepos : Call Esf_check_pagepos(pagepos , Page)
     If Ready = 0 Then
        Filname = ""
        If Filenamelen > 30 Then Filenamelen = 30
        For X = 1 To Filenamelen
          Rx_byte = Df_bufferreadbyte(1 , Pagepos)
          Filname = Filname + Chr(rx_byte)
          Incr Pagepos : Call Esf_check_pagepos(pagepos , Page)
        Next

        Rx_byte = Df_bufferreadbyte(1 , Pagepos) : Filesize = Rx_byte : Shift Filesize , Left , 8
        Incr Pagepos : Call Esf_check_pagepos(pagepos , Page)
        Rx_byte = Df_bufferreadbyte(1 , Pagepos) : Filesize = Filesize Or Rx_byte : Shift Filesize , Left , 8
        Incr Pagepos : Call Esf_check_pagepos(pagepos , Page)
        Rx_byte = Df_bufferreadbyte(1 , Pagepos) : Filesize = Filesize Or Rx_byte
        Incr Pagepos : Call Esf_check_pagepos(pagepos , Page)

        Rx_byte = Df_bufferreadbyte(1 , Pagepos) : Filepos = Rx_byte : Shift Filepos , Left , 8
        Incr Pagepos : Call Esf_check_pagepos(pagepos , Page)
        Rx_byte = Df_bufferreadbyte(1 , Pagepos) : Filepos = Filepos + Rx_byte : Shift Filepos , Left , 8
        Incr Pagepos : Call Esf_check_pagepos(pagepos , Page)
        Rx_byte = Df_bufferreadbyte(1 , Pagepos) : Filepos = Filepos + Rx_byte
        Incr Pagepos : Call Esf_check_pagepos(pagepos , Page)
        Print #1 , Filname ; "  Size: " ; Str(filesize) ; "  Pos: " ; Str(filepos)
     End If
   Loop Until Ready = 1
  End If
End Sub


Function Esf_find_file(byval Searchfile As String) As Byte
' Structure of Filetable:
' 1 Byte length filename|filename|3 Byte size|3 Bytes Startpos|
' 1 Byte length filename|filename|3 Byte size|3 Bytes Startpos|
' ...
' $00 <-- end of filetable
   Local Filesize As Dword , Filepos As Dword , Filename As String * 30 , Filenamelen As Byte
   Local Page As Word , Pagepos As Word , Count_pos As Dword
   Local Rx_byte As Byte , X As Word , Ready As Byte , Valid_files As Byte


   Count_pos = 0
   Pagepos = 1
   Ready = 0
   Esf_file_len = 0
   Esf_file_start = 0

   Page = 513
   Call Df_pagetobuffer(1 , Page)

   Valid_files = Df_bufferreadbyte(1 , 0)
   If Valid_files = &H5A Then
    Do
     Filenamelen = Df_bufferreadbyte(1 , Pagepos)
     If Filenamelen = 0 Then
        Ready = 1
     End If
     Incr Pagepos : Call Esf_check_pagepos(pagepos , Page)
     If Ready = 0 Then
        Filename = ""
        If Filenamelen > 30 Then Filenamelen = 30
        For X = 1 To Filenamelen
          Rx_byte = Df_bufferreadbyte(1 , Pagepos)
          Filename = Filename + Chr(rx_byte)
          Incr Pagepos : Call Esf_check_pagepos(pagepos , Page)
        Next

        Rx_byte = Df_bufferreadbyte(1 , Pagepos) : Filesize = Rx_byte : Shift Filesize , Left , 8
        Incr Pagepos : Call Esf_check_pagepos(pagepos , Page)
        Rx_byte = Df_bufferreadbyte(1 , Pagepos) : Filesize = Filesize Or Rx_byte : Shift Filesize , Left , 8
        Incr Pagepos : Call Esf_check_pagepos(pagepos , Page)
        Rx_byte = Df_bufferreadbyte(1 , Pagepos) : Filesize = Filesize Or Rx_byte
        Incr Pagepos : Call Esf_check_pagepos(pagepos , Page)

        Rx_byte = Df_bufferreadbyte(1 , Pagepos) : Filepos = Rx_byte : Shift Filepos , Left , 8
        Incr Pagepos : Call Esf_check_pagepos(pagepos , Page)
        Rx_byte = Df_bufferreadbyte(1 , Pagepos) : Filepos = Filepos + Rx_byte : Shift Filepos , Left , 8
        Incr Pagepos : Call Esf_check_pagepos(pagepos , Page)
        Rx_byte = Df_bufferreadbyte(1 , Pagepos) : Filepos = Filepos + Rx_byte
        Incr Pagepos : Call Esf_check_pagepos(pagepos , Page)
        Filename = Ucase(filename)
        Searchfile = Ucase(searchfile)
        If Filename = Searchfile Then
            Esf_file_start = Filepos
            Esf_file_len = Filesize
            Esf_find_file = 1
            Ready = 1
        End If
     End If
   Loop Until Ready = 1
  End If
End Function


Sub Esf_check_pagepos(byref Pagepos As Word , Byref Page As Word)
        If Pagepos > 255 Then
          Incr Page
          Pagepos = 0
          Call Df_pagetobuffer(1 , Page)
        End If
End Sub