'*******************************************************************************
'
'  Copyright Michael Koecher aka six1 8/2010
'  -> http://www.six1.net/   michael@koecher-web.de
'
'   http://creativecommons.org/licenses/by-sa/3.0/de/
'
'   Sie drfen:
'
'     * das Werk bzw. den Inhalt vervielfltigen, verbreiten und ffentlich zugnglich machen
'
'     * Abwandlungen und Bearbeitungen des Werkes bzw. Inhaltes anfertigen
'
'   Zu Den Folgenden Bedingungen:
'
'     * Namensnennung.
'       Sie mssen den Namen des Autors/Rechteinhabers in der von ihm festgelegten Weise nennen.
'
'     * Keine kommerzielle Nutzung.
'       Dieses Werk darf nicht fr kommerzielle Zwecke verwendet werden.
'
'     * Weitergabe unter gleichen Bedingungen.
'       Wenn Sie das lizenzierte Werk bzw. den lizenzierten Inhalt bearbeiten
'       oder in anderer Weise erkennbar als Grundlage fr eigenes Schaffen verwenden,
'       drfen Sie die daraufhin neu entstandenen Werke bzw. Inhalte nur
'       unter Verwendung von Lizenzbedingungen weitergeben, die mit denen
'       dieses Lizenzvertrages identisch oder vergleichbar sind.
'
'   Wobei gilt:
'
'     * Verzichtserklrung
'       Jede der vorgenannten Bedingungen kann aufgehoben werden, sofern Sie
'       die ausdrckliche Einwilligung des Rechteinhabers dazu erhalten.
'
'     * Sonstige Rechte
'       Die Lizenz hat keinerlei Einfluss auf die folgenden Rechte:
'          - Die gesetzlichen Schranken des Urheberrechts und sonstigen
'            Befugnisse zur privaten Nutzung
'          - Das Urheberpersnlichkeitsrecht des Rechteinhabers
'          - Rechte anderer Personen, entweder am Lizenzgegenstand selber oder
'            bezglich seiner Verwendung, zum Beispiel Persnlichkeitsrechte abgebildeter Personen.
'
'  Hinweis
'
'      Im Falle einer Verbreitung mssen Sie anderen alle Lizenzbedingungen
'      mitteilen, die fr dieses Werk gelten. Am einfachsten ist es,
'      einen Link auf http://creativecommons.org/licenses/by-sa/3.0/de/ einzubinden.
'

'*******************************************************************************
$nocompile

'-------------------------------------------------------------------------------
' four bytes to long value
'-------------------------------------------------------------------------------
Function Bytes2long(byval Byte_lowest As Byte , Byval Byte_low As Byte , Byval Byte_high As Byte , Byval Byte_highest As Byte) As Long
   Bytes2long = Byte_highest : Shift Bytes2long , Left , 8
   Bytes2long = Bytes2long + Byte_high : Shift Bytes2long , Left , 8
   Bytes2long = Bytes2long + Byte_low : Shift Bytes2long , Left , 8
   Bytes2long = Bytes2long + Byte_lowest
End Function

'-------------------------------------------------------------------------------
' Get_date give back Date with four digit year
'-------------------------------------------------------------------------------
Function Get_date() As String
     Local S_s As String * 8
     S_s = Date(wiz_time)
     Get_date = Mid(s_s , 1 , 2) + "." + Mid(s_s , 4 , 2) + ".20" + + Mid(s_s , 7 , 2)
End Function

'-------------------------------------------------------------------------------
' Set W5300 common Registers an reset device
'-------------------------------------------------------------------------------
Sub Wiz_init()
   Local X As Byte , Y As Byte

   'Reset Device
   Call Wiz_write(w5300_mr1 , Mr_rst)
   'wait PLL lock
   Waitms 5
   'indirect addressing
   Call Wiz_write(w5300_mr1 , Mr_ind)

   Waitms 10

   'Set memory
   '1st to 8th Memory Block as RX memory
   Call Wiz_write(w5300_mtyper0 , 0)
   '9th to 16th Memory Block as TX memory
   Call Wiz_write(w5300_mtyper1 , &HFF)

   Call Wiz_write(w5300_tmsr0 , 8)
   Call Wiz_write(w5300_tmsr1 , 8)
   Call Wiz_write(w5300_tmsr2 , 8)
   Call Wiz_write(w5300_tmsr3 , 8)
   Call Wiz_write(w5300_tmsr4 , 8)
   Call Wiz_write(w5300_tmsr5 , 8)
   Call Wiz_write(w5300_tmsr6 , 8)
   Call Wiz_write(w5300_tmsr7 , 8)

   Call Wiz_write(w5300_rmsr0 , 8)
   Call Wiz_write(w5300_rmsr1 , 8)
   Call Wiz_write(w5300_rmsr2 , 8)
   Call Wiz_write(w5300_rmsr3 , 8)
   Call Wiz_write(w5300_rmsr4 , 8)
   Call Wiz_write(w5300_rmsr5 , 8)
   Call Wiz_write(w5300_rmsr6 , 8)
   Call Wiz_write(w5300_rmsr7 , 8)
   Waitms 5
   Call Eeram_setup_network
   'Set gateway adress
   Call Wiz_set_network(1 , W5300_gw(1))
   'Set Mask
   Call Wiz_set_network(2 , W5300_mask(1))
   'Set Ip adress
   Call Wiz_set_network(3 , W5300_ip(1))
   'Set Mac adress
   Call Wiz_set_network(4 , W5300_mac(1))
   'set Interrupt Mask
   Call Wiz_write(w5300_imr0 , &H0F)
   'for getting Sock Int should be $FF for 8 Socks
   'Allow Interrupts on Sockets
   Call Wiz_write(w5300_imr1 , $ff)

   'read RX/TX free Memsize per Socket
   'dummy send 1st time

   For X = 1 To 8
       Print #1 , "Socket " ; X ; " Free size   TX " ; Get_tx_size(x) ; " Byte"
       Call Sock_stack_reset(x)
   Next
End Sub


'-------------------------------------------------------------------------------
' Set Network Parameters
'-------------------------------------------------------------------------------
Sub Wiz_set_network(byval Typ As Byte , Byref Address As Byte)
   Local Dest_address As Word , Laddr As Word , Lb As Byte , Count As Byte , X As Byte
   Select Case Typ
     'Gateway
     Case 1 : Dest_address = W5300_gar0
               Count = 4
     'Mask
     Case 2 : Dest_address = W5300_subr0
               Count = 4
    'Ip
     Case 3 : Dest_address = W5300_sipr0
               Count = 4
    'Mac
     Case 4 : Dest_address = W5300_shar0
               Count = 6
    'NTP
     Case 5 : Dest_address = Varptr(w5300_time_server(1))
               Count = 4
    'DHCP
     Case 6 : Dest_address = Varptr(dhcp_b_recent_server_ip(1))
               Count = 4
     Case Else Exit Sub
   End Select
   Laddr = Varptr(address) : Lb = Inp(laddr)
   For X = 1 To Count
     Call Wiz_write(dest_address , Lb)
     Incr Dest_address
     Incr Laddr
     Lb = Inp(laddr)
   Next
End Sub


'-------------------------------------------------------------------------------
' wait while TX Buff is sended
'-------------------------------------------------------------------------------
Sub Wiz_wait_tx(byval Socket_number As Byte)
   Local Timeout As Word
   Local Interrupt As Byte
   Do
     Incr Timeout
     Interrupt = Wiz_read_socket(socket_number , W5300_s0_ir1 )
   Loop Until Interrupt.sn_ir_sendok = 1 Or Timeout > 60000
   If Timeout > 60000 Then
    #if W5300_debug > 0
      Print #1 , "TIMEOUT: Wiz_wait_tx"
    #endif
   End If
End Sub

'-------------------------------------------------------------------------------
' Checkout RX on Socks
'-------------------------------------------------------------------------------
Sub Wiz_rx
   Local Socket_number As Byte , Socket_stat As Byte , Rx_size As Word , Sock_int As Byte

   For Socket_number = 1 To 8
      Sock_int = Wiz_read_socket(socket_number , W5300_s0_ir1 )
      If Sock_int.sn_ir_discon = 1 Then
         'this is for click-kidies :-)
         'if links are clicked many times, before the files are completly loaded
         'we've to interrupt the file send transfer. otherwise wiz200 will reset!
         Call Wiz_write_socket(socket_number , W5300_s0_ir1 , &HFF )
         Call Wiz_write_socket(socket_number , W5300_s0_cr1 , Sn_cr_recv)
         Call Socket_close(socket_number)
      Else
         Rx_size = Get_rx_size(socket_number)
         If Rx_size > 0 Then
'         If Sock_int.sn_ir_recv = 1 Then
            Socket_stat = Get_socket_status(socket_number)
            If Socket_stat = Sock_established Then Call Wiz_tcp(socket_number)
            If Socket_stat = Sock_udp Then Call Wiz_udp(socket_number)
         End If
      End If
   Next
End Sub

'-------------------------------------------------------------------------------
'   Write Wiznet Base Register Adress Data
'-------------------------------------------------------------------------------
Sub Wiz_write(byval Address_a As Word , Byval Data_a As Byte)
   Out Address_a , Data_a
End Sub

'-------------------------------------------------------------------------------
'   Read Wiznet Base Register Adress Data
'-------------------------------------------------------------------------------
Function Wiz_read(byval A As Word) As Byte
   Wiz_read = Inp(a)
End Function

'-------------------------------------------------------------------------------
'   Write Wiznet Socket Register Adress Data
'-------------------------------------------------------------------------------
Sub Wiz_write_socket(byval Socket_number As Byte , Byval Register As Word , Byval Data_a As Byte)
   Local Add_address As Word , Address As Word

   'calculate Socket Address
   Add_address = Socket_number
   Decr Add_address
   Add_address = Add_address * Socket_reg_size

   Address = Add_address + Register
   Out Address , Data_a
End Sub

'-------------------------------------------------------------------------------
'   Read Wiznet Socket Register Adress Data
'-------------------------------------------------------------------------------
Function Wiz_read_socket(byval Socket_number As Byte , Byval Register As Word) As Byte
   Local Add_address As Word , Address As Word

   'calculate Socket Address
   Add_address = Socket_number
   Decr Add_address
   Add_address = Add_address * Socket_reg_size

   Address = Add_address + Register
   Wiz_read_socket = Inp(address)
End Function

'-------------------------------------------------------------------------------
' for safty :-)  don't like hanging Sock's
'-------------------------------------------------------------------------------
Sub Check_timeout()
  Local Sock_count As Byte , Sock_status As Byte
     For Sock_count = 1 To Wiz_stack_max
      Sock_status = Get_socket_status(sock_count)
      If Sock_status = Sock_established Or Sock_status = Sock_udp Then
         If Wiz_stack_timeout(sock_count) > 0 Then
           Decr Wiz_stack_timeout(sock_count)

           If Wiz_stack_timeout(sock_count) = 0 And Sock_count <> Mysql_sock Then
             #if W5300_debug > 0
                Print #1 , "Timeout! Sock " ; Sock_count
             #endif
             If Sock_status = Sock_established Then
                 Call Socket_close(sock_count)
             End If
             If Sock_status = Sock_udp Then
                Call Socket_close(sock_count)
             End If
         End If
       End If
      End If
    Next
End Sub

'-------------------------------------------------------------------------------
'   Close Socket
'-------------------------------------------------------------------------------
Sub Socket_close(byval Socket_number As Byte)
   Local Rx_size As Word , Socket_stat As Byte
         Rx_size = Get_rx_size(socket_number)
         If Rx_size > 0 Then
            Socket_stat = Get_socket_status(socket_number)
            If Socket_stat = Sock_established Then Call Wiz_tcp(socket_number)
            If Socket_stat = Sock_udp Then Call Wiz_udp(socket_number)
         End If

   Call Wiz_write_socket(socket_number , W5300_s0_cr1 , Sn_cr_close)       'close socket
 '  Call Wiz_write_socket(socket_number , W5300_s0_ir1 , $0001_0000 )
   Call Sock_stack_reset(socket_number)
   #if Mysql_sock > 0
     If Socket_number = Mysql_sock Then
       Mysql_flag.mysql_try_connect = 0
       Mysql_flag.mysql_connected = 0
       Mysql_step = 0
       Mysql_flag.mysql_wait = 0
       #if Mysql_debug = 1
          Print #1 , "   Mysql Sock closed!"
       #endif
     End If
   #endif
End Sub

'-------------------------------------------------------------------------------
'   Reset Sock Variables
'-------------------------------------------------------------------------------
Sub Sock_stack_reset(byval Socket_number As Byte)
   Wiz_stack_filename(socket_number) = ""
   Wiz_stack_filepos(socket_number) = 0
   Wiz_stack_filesize(socket_number) = 0
   Wiz_stack_file_ext(socket_number) = ""
   Wiz_stack_cgi(socket_number) = ""
   Wiz_stack_timeout(socket_number) = 0
End Sub

'-------------------------------------------------------------------------------
'(
   Open Socket

      Socket_number = 1 - 8

      Protokoll(modus):
      1 = Sn_mr_tcp = &H01                                                      ' TCP
      2 = Sn_mr_udp = &H02                                                      ' UDP
      3 = Sn_mr_ipraw = &H03                                                    ' IP LAYER RAW SOCK
      4 = Sn_mr_macraw = &H04                                                   ' MAC LAYER RAW SOCK
      5 = Sn_mr_pppoe = &H05                                                    ' PPPoE

      Port : 0 - 65535

      Modus
        0 = Normal
        1 = Webserver Listen Mode!
        3 = Client Mode connect to Server
')
'-------------------------------------------------------------------------------
Sub Socket_open(byval Socket_number As Byte , Byval Protokoll As Byte , Byval Src_port As Word , Byval Dst_port As Word , Byref Dst_ip As Byte , Byval Modus As Byte)
   Local Laddr As Word
   Local Lb As Byte
   Local Z As Byte , Prot_value As Byte , Y As Word
   'Protokoll
   if Protokoll = Sn_mr_tcp Then
     Call Wiz_write_socket(socket_number , W5300_s0_mr0 , Sn_mr0_align)
   Else
     Call Wiz_write_socket(socket_number , W5300_s0_mr0 , 0)
   End If
   Call Wiz_write_socket(socket_number , W5300_s0_mr1 , Protokoll)
   'Source Port
   Tmp_port = Src_port
   Call Wiz_write_socket(socket_number , W5300_s0_portr0 , Tmp_port_h)
   Call Wiz_write_socket(socket_number , W5300_s0_portr1 , Tmp_port_l)

   'set normal MTU Size
    Z = High(wiz_mtu_size)
    Call Wiz_write_socket(socket_number , W5300_s0_mssr0 , Z)
    Z = Low(wiz_mtu_size)
    Call Wiz_write_socket(socket_number , W5300_s0_mssr1 , Z)

   If Modus = 0 Or Modus = 3 Then
      'Destination Port
      Tmp_port = Dst_port
      Call Wiz_write_socket(socket_number , W5300_s0_dportr0 , Tmp_port_h)
      Call Wiz_write_socket(socket_number , W5300_s0_dportr1 , Tmp_port_l)
      'Destination IP Address
      Laddr = Varptr(dst_ip) : Lb = Inp(laddr)
      Call Wiz_write_socket(socket_number , W5300_s0_dipr0 , Lb)
      Incr Laddr : Lb = Inp(laddr)
      Call Wiz_write_socket(socket_number , W5300_s0_dipr1 , Lb)
      Incr Laddr : Lb = Inp(laddr)
      Call Wiz_write_socket(socket_number , W5300_s0_dipr2 , Lb)
      Incr Laddr : Lb = Inp(laddr)
      Call Wiz_write_socket(socket_number , W5300_s0_dipr3 , Lb)
   End If

   Call Wiz_write_socket(socket_number , W5300_s0_cr1 , Sn_cr_open)       'Open
   ' wait on Sock opened
   If Protokoll = Sn_mr_tcp Then Prot_value = Sock_init
   If Protokoll = Sn_mr_udp Then Prot_value = Sock_udp
   If Protokoll = Sn_mr_ipraw Then Prot_value = Sock_ipraw
   If Protokoll = Sn_mr_macraw Then Prot_value = Sock_macraw
   If Protokoll = Sn_mr_pppoe Then Prot_value = Sock_pppoe
   Do
      Z = Get_socket_status(socket_number)
   Loop Until Z = Prot_value

   'Server Mode listen
   If Modus = 1 Then
      Call Wiz_write_socket(socket_number , W5300_s0_cr1 , Sn_cr_listen)
   End If
   'Client Mode connect to Server
   If Modus = 3 Then
     Lb = 0
     Restart_connect:
      Call Wiz_write_socket(socket_number , W5300_s0_cr1 , Sn_cr_connect)
      'wait on Sock established
      Y = 0
      Do
        Z = Get_socket_status(socket_number)
        Incr Y
      Loop Until Z = Sock_established Or Y > &H9FFF
      Incr Lb
      If Y > &H9FFF Then
         Reset Watchdog
         Print #1 , "Can't open Sock Try " ; Lb
         If Lb < 3 Then Goto Restart_connect
      End If
   End If
   Wiz_stack_timeout(socket_number) = Wiz_stack_timeout_value
End Sub


'-------------------------------------------------------------------------------
'   Get Socket Status
'   Socket_number = 1 - 8
'-------------------------------------------------------------------------------
Function Get_socket_status(byval Socket_number As Byte) As Byte
   Local X As Byte , Y As Byte

   X = Wiz_read_socket(socket_number , W5300_s0_ssr1 )
   Do
      Y = Wiz_read_socket(socket_number , W5300_s0_ssr1 )
      If X = Y Then Exit Do
      X = Y
   Loop
   Get_socket_status = X
End Function

'-------------------------------------------------------------------------------
'   Get Free Socket
'   Socket_number = 1 - 8
'   0 = "no free Sock"
'-------------------------------------------------------------------------------
Function Get_free_socket() As Byte
   Local X As Byte , W As Byte
   Get_free_socket = 0
   For X = 1 To Wiz_stack_max
      W = X - 1
      If Webserver_socks.w = 1 Then
        If Get_socket_status(x) = Sock_closed Then
           Get_free_socket = X
           Exit For
        End If
     End If
   Next
End Function

'-------------------------------------------------------------------------------
' Debug output of Sock Stats
'-------------------------------------------------------------------------------
Sub Dump_socket_stats
   Local Z As Byte , X As Byte , W As Byte
   Print #1 , "---------------------------"
   Print #1 , "Sock Status        File  timeout filepos filesize"
   For X = 1 To 8
      W = X - 1
         Z = Get_socket_status(x)
         Print #1 , " " ; X ; "  ";
         Select Case Z
           Case Sock_closed : Print #1 , " Sock_closed";
           Case Sock_init : Print #1 , " Sock_init";
           Case Sock_listen : Print #1 , " Sock_listen";
           Case Sock_synsent : Print #1 , " Sock_synsent";
           Case Sock_established : Print #1 , " Sock_established";
           Case Sock_fin_wait : Print #1 , " Sock_fin_wait";
           Case Sock_closing : Print #1 , " Sock_closing";
           Case Sock_time_wait : Print #1 , " Sock_time_wait";
           Case Sock_close_wait : Print #1 , " Sock_close_wait";
           Case Sock_last_ack : Print #1 , " Sock_last_ack";
           Case Sock_udp : Print #1 , " Sock_udp";
           Case Sock_ipraw : Print #1 , " Sock_ipraw";
           Case Sock_macraw : Print #1 , " Sock_macraw";
           Case Sock_pppoe : Print #1 , " Sock_pppoe";
         Case Else : Print #1 , "unkonown 0x" ; Hex(z);
       End Select
       Print #1 , "  " ; Wiz_stack_filename(x);
       Print #1 , " " ; Wiz_stack_timeout(x) ;
       Print #1 , " " ; Wiz_stack_filepos(x);
       Print #1 , " " ; Wiz_stack_filesize(x)
   Next
   Print #1 , "---------------------------"
End Sub

'-------------------------------------------------------------------------------
'   Get Rx Size on Sock
'-------------------------------------------------------------------------------
Function Get_rx_size(byval Socket_number As Byte) As Word
   Local Temp As Word
   Local Tries As Byte
'(
   Tries = 0
   Temp = 0
   Do
      'we do it only on two Registers, because we can't handle more than 64KB!
      Adres16_h = Wiz_read_socket(socket_number , W5300_s0_rx_rsr2)
      Adres16_l = Wiz_read_socket(socket_number , W5300_s0_rx_rsr3)
      'wait until there is no change in size anymore!
      If Adres16 = Temp Then
         Incr Tries
      End If
      Temp = Adres16
   Loop Until Tries > 2
')
   'Adres16_h = Wiz_read_socket(socket_number , W5300_s0_rx_rsr2)
   'Adres16_l = Wiz_read_socket(socket_number , W5300_s0_rx_rsr3)
   Adres32_1 = Wiz_read_socket(socket_number , W5300_s0_rx_rsr3)
   Adres32_2 = Wiz_read_socket(socket_number , W5300_s0_rx_rsr2)
   Adres32_3 = Wiz_read_socket(socket_number , W5300_s0_rx_rsr1)
   Adres32_4 = Wiz_read_socket(socket_number , W5300_s0_rx_rsr0)

   Get_rx_size = Adres32
End Function

'-------------------------------------------------------------------------------
'   Get Free Tx Buffer Size
'-------------------------------------------------------------------------------
Function Get_tx_size(byval Socket_number As Byte) As Word
   Local Temp As Word
   Local Tries As Byte
   Tries = 0
   Do
      Adres16_h = Wiz_read_socket(socket_number , W5300_s0_tx_fsr2)
      Adres16_l = Wiz_read_socket(socket_number , W5300_s0_tx_fsr3)
      'wait until there is no change in size anymore!
      If Adres16 = Temp Then
         Incr Tries
 '        Temp = 0
      End If
      Temp = Adres16
   Loop Until Tries > 3
   Get_tx_size = Adres16
End Function


'-------------------------------------------------------------------------------
'  Fill Wiz Buff from peer Buff
'-------------------------------------------------------------------------------
Sub Wiz_write_databuf(byval Socket_number As Byte , Byval Data_len As Word )       ', Byref From_buffer As Byte)
   Local Max_buffer_size As Word
   Local D As Word
   Local Add_address As Word , Address As Word
   Local Fifo0_addr As Word
   Local Fifo1_addr As Word
'   Local Laddr As Word

'   Laddr = Varptr(from_buffer)

   'calculate Socket Address
   Add_address = Socket_number
   Decr Add_address
   Add_address = Add_address * Socket_reg_size
   Fifo0_addr = Add_address + W5300_s0_tx_fifor0
   Fifo1_addr = Add_address + W5300_s0_tx_fifor1
   Max_buffer_size = Get_tx_size(socket_number)
   If Data_len > Max_buffer_size Then
      Data_len = Max_buffer_size
   End If
   Adres16 = Data_len
   If Data_len.0 = 1 Then Incr Data_len
   For D = 1 To Data_len Step 2
     Out Fifo0_addr , W5300_payload_byte(d)                 'High adress
     Out Fifo1_addr , W5300_payload_byte(d + 1)             'low  adress
'     Out Fifo0_addr , Laddr(d)                                                  'High adress
'     Out Fifo1_addr , Laddr(d + 1)                                              'low  adress
   Next
   ' Set Write Size Register
   Call Wiz_write_socket(socket_number , W5300_s0_tx_wrsr0 , &H0)
   Call Wiz_write_socket(socket_number , W5300_s0_tx_wrsr1 , &H0)
   Call Wiz_write_socket(socket_number , W5300_s0_tx_wrsr2 , Adres16_h)
   Call Wiz_write_socket(socket_number , W5300_s0_tx_wrsr3 , Adres16_l)

End Sub