'*******************************************************************************
'
'  Copyright Michael Koecher aka six1 8/2010
'  based on Code from Framuel/Bascom-Forum.de
'  -> http://www.six1.net/   michael@koecher-web.de
'
'   http://creativecommons.org/licenses/by-sa/3.0/de/
'
'   Sie drfen:
'
'     * das Werk bzw. den Inhalt vervielfltigen, verbreiten und ffentlich zugnglich machen
'
'     * Abwandlungen und Bearbeitungen des Werkes bzw. Inhaltes anfertigen
'
'   Zu Den Folgenden Bedingungen:
'
'     * Namensnennung.
'       Sie mssen den Namen des Autors/Rechteinhabers in der von ihm festgelegten Weise nennen.
'
'     * Keine kommerzielle Nutzung.
'       Dieses Werk darf nicht fr kommerzielle Zwecke verwendet werden.
'
'     * Weitergabe unter gleichen Bedingungen.
'       Wenn Sie das lizenzierte Werk bzw. den lizenzierten Inhalt bearbeiten
'       oder in anderer Weise erkennbar als Grundlage fr eigenes Schaffen verwenden,
'       drfen Sie die daraufhin neu entstandenen Werke bzw. Inhalte nur
'       unter Verwendung von Lizenzbedingungen weitergeben, die mit denen
'       dieses Lizenzvertrages identisch oder vergleichbar sind.
'
'   Wobei gilt:
'
'     * Verzichtserklrung
'       Jede der vorgenannten Bedingungen kann aufgehoben werden, sofern Sie
'       die ausdrckliche Einwilligung des Rechteinhabers dazu erhalten.
'
'     * Sonstige Rechte
'       Die Lizenz hat keinerlei Einfluss auf die folgenden Rechte:
'          - Die gesetzlichen Schranken des Urheberrechts und sonstigen
'            Befugnisse zur privaten Nutzung
'          - Das Urheberpersnlichkeitsrecht des Rechteinhabers
'          - Rechte anderer Personen, entweder am Lizenzgegenstand selber oder
'            bezglich seiner Verwendung, zum Beispiel Persnlichkeitsrechte abgebildeter Personen.
'
'  Hinweis
'
'      Im Falle einer Verbreitung mssen Sie anderen alle Lizenzbedingungen
'      mitteilen, die fr dieses Werk gelten. Am einfachsten ist es,
'      einen Link auf http://creativecommons.org/licenses/by-sa/3.0/de/ einzubinden.
'

'*******************************************************************************
$nocompile

'-------------------------------------------------------------------------------
'  DHCP-packet filter
'-------------------------------------------------------------------------------
Sub Dhcp_packet_filter(byval Socket_number As Byte)
Local Lw As Word
   If Dhcp_status = Dhcp_status_bound Then
      Call Wiz_write_socket(socket_number , W5300_s0_cr1 , Sn_cr_close)
      Exit Sub                                                                  'Don't accept packets anymore
   End If
   If Dhcp_b_opcode = Dhcp_op_bootreply Then
     If Dhcp_l_transaction_id = Dhcp_transaction_id Then
        Lw = Dhcp_find_option(53)
        If Lw = 0 Then Exit Sub
        Select Case Dhcp_msg(lw + 2)
           Case Dhcp_msg_type_dhcpoffer
              Call Dhcp_send_request(socket_number)
           Case Dhcp_msg_type_dhcpack
              Call Dhcp_received_ack
              Call Socket_close(socket_number)
           Case Dhcp_msg_type_dhcpnak
              Call Dhcp_received_nak
              Call Socket_close(socket_number)
           Case Else
              #if Debug_dhcp > 0
                  Print #1 , "DHCP other packet received from IP "
              #endif
        End Select
     End If
  End If
End Sub

'-------------------------------------------------------------------------------
'  DHCP Initialization
'-------------------------------------------------------------------------------
Sub Dhcp_initialize(byval Socket_number As Byte)
   Dhcp_status = Dhcp_status_init
   #if Debug_dhcp > 1
      Print #1 , "DHCP Status set to INIT"
   #endif
   Call Dhcp_send_discover(socket_number)
End Sub

'-------------------------------------------------------------------------------
'  DHCP Every Minute
'-------------------------------------------------------------------------------
Sub Dhcp_every_minute(byval Socket_number As Byte)
   If Socket_number = 0 Then Socket_number = Get_free_socket()
   If Socket_number = 0 Then
       Print #1 , " No free Socket for DHCP!"
      Exit Sub
   End If
   Select Case Dhcp_renew_time                                                  'T1
'      Case &HFFFFFFFF                                                           'infinite
      Case Is > 0:
         Dhcp_renew_time = Dhcp_renew_time - 60                                 '-60 secs
         If Dhcp_renew_time <= 0 Then
            Dhcp_status = Dhcp_status_renewing
            #if Debug_dhcp > 1
                Print #1 , "  DHCP Status changed to RENEWING"
            #endif
         End If
'      Case Else
   End Select
   Select Case Dhcp_rebinding_time                                              'T2
'      Case &HFFFFFFFF                                                           'infinite
      Case Is > 0:
         Dhcp_rebinding_time = Dhcp_rebinding_time - 60                         '-60 sec
         If Dhcp_rebinding_time <= 0 Then
            Dhcp_status = Dhcp_status_rebinding
            #if Debug_dhcp > 1
                Print #1 , "  DHCP Status changed to REBINDING"
            #endif
         End If
'      Case Else
   End Select
   Select Case Dhcp_lease_time
'      Case &HFFFFFFFF                                                           'infinite
      Case Is > 0:
         Dhcp_lease_time = Dhcp_lease_time - 60                                 '-60 sec
         If Dhcp_lease_time <= 0 Then
            Call Wiz_init                                                       'reset to static network
            Dhcp_status = Dhcp_status_init
            #if Debug_dhcp > 1
                Print #1 , "  DHCP Status changed to INIT"
            #endif
         End If
'      Case Else
   End Select
   Dhcp_secs_elapsed = Dhcp_secs_elapsed + 60

   #if Debug_dhcp > 1
      Print
      Select Case Dhcp_status
         Case Dhcp_status_init
             Print #1 , "DHCP Status = INIT"
         Case Dhcp_status_renewing
             Print #1 , "DHCP Status = RENEWING"
         Case Dhcp_status_rebinding
             Print #1 , "DHCP Status = REBINDING"
         Case Dhcp_status_bound
             Print #1 , "DHCP Status = BOUND"
      End Select
       Print #1 , " Renew  Tmr = " ; Dhcp_renew_time
       Print #1 , " Rebind Tmr = " ; Dhcp_rebinding_time
       Print #1 , " Lease  Tmr = " ; Dhcp_lease_time
       Print #1 , "SecsElapsed = " ; Dhcp_secs_elapsed
   #endif

   Call Socket_close(socket_number)
   Select Case Dhcp_status
      Case Dhcp_status_bound
         Dhcp_request_time = Wiz_time + 60
         Exit Sub
      Case Dhcp_status_init
         Call Dhcp_send_discover(socket_number)
         Wiz_stack_timeout(socket_number) = Wiz_stack_timeout_value
         Dhcp_request_time = Wiz_time + 5
      Case Else
         Call Dhcp_send_request(socket_number)
         Wiz_stack_timeout(socket_number) = Wiz_stack_timeout_value
         Dhcp_request_time = Wiz_time + 5
   End Select
End Sub

'-------------------------------------------------------------------------------
'  DHCP send Discover
'-------------------------------------------------------------------------------
Sub Dhcp_send_discover(byval Socket_number As Byte)
   Local Lw As Word , L1 As Word , L2 As Word
   Local Ls As String * 1
   Local Li As Integer
Local I As Integer , Row As String * 55 , Rownr As Word

   Dhcp_b_opcode = Dhcp_op_bootrequest
   Dhcp_b_hwtype = Dhcp_hwtype_eth10mb
   Dhcp_b_hwlen = 6
   Dhcp_b_hops = 0

  Call Dhcp_create_new_xid()

   Dhcp_l_transaction_id = Dhcp_transaction_id
   Dhcp_w_flags = Dhcp_flags_broadcast

'###############################################################################
   Dhcp_b_ciaddr(1) = 0                                                         'Set all addresses to zero
   Dhcp_b_ciaddr(2) = 0
   Dhcp_b_ciaddr(3) = 0
   Dhcp_b_ciaddr(4) = 0

   Dhcp_b_yiaddr(1) = 0
   Dhcp_b_yiaddr(2) = 0
   Dhcp_b_yiaddr(3) = 0
   Dhcp_b_yiaddr(4) = 0

   Dhcp_b_siaddr(1) = 0
   Dhcp_b_siaddr(2) = 0
   Dhcp_b_siaddr(3) = 0
   Dhcp_b_siaddr(4) = 0

   Dhcp_b_offer_ip(1) = Dhcp_b_yiaddr(1)
   Dhcp_b_offer_ip(2) = Dhcp_b_yiaddr(2)
   Dhcp_b_offer_ip(3) = Dhcp_b_yiaddr(3)
   Dhcp_b_offer_ip(4) = Dhcp_b_yiaddr(4)

   Dhcp_b_dhcp_ip(1) = Dhcp_b_siaddr(1)
   Dhcp_b_dhcp_ip(2) = Dhcp_b_siaddr(2)
   Dhcp_b_dhcp_ip(3) = Dhcp_b_siaddr(3)
   Dhcp_b_dhcp_ip(4) = Dhcp_b_siaddr(4)

   For I = 1 To 4
     Dhcp_b_giaddr(i) = 0
   Next
   For I = 1 To 16
     Dhcp_b_chaddr(i) = 0
   Next
   For I = 1 To 64
     Dhcp_b_sname(i) = 0
   Next
   For I = 1 To 128
     Dhcp_b_file(i) = 0
   Next

'###############################################################################

   Dhcp_b_chaddr(1) = W5300_mac(1)
   Dhcp_b_chaddr(2) = W5300_mac(2)
   Dhcp_b_chaddr(3) = W5300_mac(3)
   Dhcp_b_chaddr(4) = W5300_mac(4)
   Dhcp_b_chaddr(5) = W5300_mac(5)
   Dhcp_b_chaddr(6) = W5300_mac(6)
   Dhcp_l_dhcp_cookie = Dhcp_cookie

'###############################################################################
'W5300 creates Header Ethernet-, IP-, UDP- and Parts of the BootStrap-Protokoll (0x0000-0119 / #000-281)
'incl. the Magic Cookie

'Start building the BootStrap-Option of the DHCP-Frame                          (0x011A-024D / #282-590)
   Lw = Dhcp_options_start                                                      'Start ByteCounting (0x011A      / #282

'1st Option - DISCOVER-Request
   Dhcp_msg(lw) = Dhcp_opt_message_type                                         'Option  53
   Incr Lw : Dhcp_msg(lw) = 1                                                   'Length
   Incr Lw : Dhcp_msg(lw) = Dhcp_msg_type_dhcpdiscover                          'Dhcp_request

'2nd Option - Client Identifier
   Incr Lw : Dhcp_msg(lw) = Dhcp_opt_client_identifier                          'Option 61
   Incr Lw : Dhcp_msg(lw) = 7                                                   'Length
   Incr Lw : Dhcp_msg(lw) = 1                                                   'HardwareType
   Incr Lw : Dhcp_msg(lw) = W5300_mac(1)
   Incr Lw : Dhcp_msg(lw) = W5300_mac(2)
   Incr Lw : Dhcp_msg(lw) = W5300_mac(3)
   Incr Lw : Dhcp_msg(lw) = W5300_mac(4)
   Incr Lw : Dhcp_msg(lw) = W5300_mac(5)
   Incr Lw : Dhcp_msg(lw) = W5300_mac(6)

'3rd Option - Host Name
   Incr Lw : Dhcp_msg(lw) = Dhcp_opt_hostname                                   'Option 12
   Incr Lw : Dhcp_msg(lw) = Len(wiz_hostname)                                   'Length
   For Li = 1 To Len(wiz_hostname)                                              'Hostname
      Ls = Mid(wiz_hostname , Li , 1)
      Incr Lw : Dhcp_msg(lw) = Asc(ls)
   Next Li

'4th Option - Parameter Request List
   Incr Lw : Dhcp_msg(lw) = Dhcp_opt_parameter_request_list                     'Option 55
   Incr Lw : Dhcp_msg(lw) = 7                                                   'Size of Options
   Incr Lw : Dhcp_msg(lw) = Dhcp_opt_subnetmask
   Incr Lw : Dhcp_msg(lw) = Dhcp_opt_routersonsubnet
   Incr Lw : Dhcp_msg(lw) = Dhcp_opt_dns
   Incr Lw : Dhcp_msg(lw) = Dhcp_opt_domainname
   Incr Lw : Dhcp_msg(lw) = Dhcp_opt_renewal
   Incr Lw : Dhcp_msg(lw) = Dhcp_opt_rebinding
   Incr Lw : Dhcp_msg(lw) = Dhcp_opt_ntp_server

'DHCP Options END'
   Incr Lw : Dhcp_msg(lw) = &HFF                                                'end

'Padding up to 548 Bytes BootStartSize
   Incr Lw
   For I = Lw To 547                                                            '590-43
     Incr Lw : Dhcp_msg(lw) = 0
   Next


'###############################################################################
#if Debug_dhcp > 2

  Print #1 , "DHCP - Send DISCOVER (Bootstrap Protocol)"
  Print #1 , "DHCP - Bootstrap Size = " ; Lw
  Print #1 , "_____________________________________________________"
  Print #1 , "0x   00 01 02 03 04 05 06 07  08 09 0A 0B 0C 0D 0E 0F"
  Print #1 , "====================================================="
  Row = "0020 -- -- -- -- -- -- -- --  -- --"
  Rownr = 32
  For I = 1 To Lw
    Row = Row + " " + + Hex(dhcp_msg(i))
    If Len(row) = 28 Then
      Row = Row + " "
    End If
    If Len(row) >= 52 Then
      Print #1 , Row
      Rownr = Rownr + 16
      Row = Hex(rownr)
    End If
  Next
  Print #1 , Row                                                                'the rest

  Print #1 , "_____________________________________________________"

#endif
'###############################################################################


'Set Destination- and Source-IP
   W5300_dest_ip(1) = 255
   W5300_dest_ip(2) = 255
   W5300_dest_ip(3) = 255
   W5300_dest_ip(4) = 255

'   W5300_ip(1) = 0
'   W5300_ip(2) = 0
'   W5300_ip(3) = 0
'   W5300_ip(4) = 0
'  Call Wiz_set_network(3 , W5300_ip(1))

   ' open socket
   Call Socket_open(socket_number , Sn_mr_udp , Udp_port_dhcp_local , Udp_port_dhcp_remote , W5300_dest_ip(1) , 0 )
   ' updata txbuf pointer, send data
   Call Udp_write_databuf(socket_number , Lw)
   ' updata txbuf pointer, send data
   Call Wiz_write_socket(socket_number , W5300_s0_cr1 , Sn_cr_send)
End Sub




'-------------------------------------------------------------------------------
'  DHCP send Request
'-------------------------------------------------------------------------------
Sub Dhcp_send_request(byval Socket_number As Byte)
Local Lw As Word , L1 As Word , L2 As Word
Local Li As Integer
Local Ls As String * 1
Local I As Integer
Local Opt_pos As Word

   Dhcp_b_offer_ip(1) = Dhcp_b_yiaddr(1)
   Dhcp_b_offer_ip(2) = Dhcp_b_yiaddr(2)
   Dhcp_b_offer_ip(3) = Dhcp_b_yiaddr(3)
   Dhcp_b_offer_ip(4) = Dhcp_b_yiaddr(4)

   If Dhcp_b_siaddr(1) > 0 Then
      Dhcp_b_dhcp_ip(1) = Dhcp_b_siaddr(1)
      Dhcp_b_dhcp_ip(2) = Dhcp_b_siaddr(2)
      Dhcp_b_dhcp_ip(3) = Dhcp_b_siaddr(3)
      Dhcp_b_dhcp_ip(4) = Dhcp_b_siaddr(4)
   Else
      Opt_pos = Dhcp_find_option(dhcp_opt_server_identifier)
      If Opt_pos > 0 Then
        Dhcp_b_dhcp_ip(1) = Dhcp_msg(opt_pos + 2)
        Dhcp_b_dhcp_ip(2) = Dhcp_msg(opt_pos + 3)
        Dhcp_b_dhcp_ip(3) = Dhcp_msg(opt_pos + 4)
        Dhcp_b_dhcp_ip(4) = Dhcp_msg(opt_pos + 5)
      Else
        ' didn't know, where to get adress from....
      End If
   End If

'###############################################################################
   Dhcp_b_yiaddr(1) = 0                                                         ' Set your Client IP to zero again
   Dhcp_b_yiaddr(2) = 0
   Dhcp_b_yiaddr(3) = 0
   Dhcp_b_yiaddr(4) = 0

   Dhcp_b_siaddr(1) = 0                                                         ' Set next server IP to zero again
   Dhcp_b_siaddr(2) = 0
   Dhcp_b_siaddr(3) = 0
   Dhcp_b_siaddr(4) = 0
'###############################################################################


   W5300_dest_ip(1) = 255
   W5300_dest_ip(2) = 255
   W5300_dest_ip(3) = 255
   W5300_dest_ip(4) = 255


   Dhcp_b_opcode = Dhcp_op_bootrequest
   Dhcp_b_hwtype = Dhcp_hwtype_eth10mb
   Dhcp_b_hwlen = 6
   Dhcp_b_hops = 0
   Dhcp_l_transaction_id = Dhcp_transaction_id

   If Dhcp_status < Dhcp_status_renewing Then
      Dhcp_w_flags = Dhcp_flags_broadcast
   Else
      Dhcp_w_flags = 0
      Dhcp_b_ciaddr(1) = W5300_ip(1)
      Dhcp_b_ciaddr(2) = W5300_ip(2)
      Dhcp_b_ciaddr(3) = W5300_ip(3)
      Dhcp_b_ciaddr(4) = W5300_ip(4)
   End If

   Dhcp_b_chaddr(1) = W5300_mac(1)
   Dhcp_b_chaddr(2) = W5300_mac(2)
   Dhcp_b_chaddr(3) = W5300_mac(3)
   Dhcp_b_chaddr(4) = W5300_mac(4)
   Dhcp_b_chaddr(5) = W5300_mac(5)
   Dhcp_b_chaddr(6) = W5300_mac(6)

   Dhcp_l_dhcp_cookie = Dhcp_cookie

'Options Request Parameter
   Lw = Dhcp_options_start
   Dhcp_msg(lw) = Dhcp_opt_message_type                                         'option  53
   Incr Lw : Dhcp_msg(lw) = &H01                                                'Length
   Incr Lw : Dhcp_msg(lw) = Dhcp_msg_type_dhcprequest                           'Dhcp_request

   Incr Lw : Dhcp_msg(lw) = Dhcp_opt_client_identifier

   Incr Lw : Dhcp_msg(lw) = &H07                                                'Length
   Incr Lw : Dhcp_msg(lw) = &H01                                                'Hardwaretyp = Ethernet

   Incr Lw : Dhcp_msg(lw) = W5300_mac(1)
   Incr Lw : Dhcp_msg(lw) = W5300_mac(2)
   Incr Lw : Dhcp_msg(lw) = W5300_mac(3)
   Incr Lw : Dhcp_msg(lw) = W5300_mac(4)
   Incr Lw : Dhcp_msg(lw) = W5300_mac(5)
   Incr Lw : Dhcp_msg(lw) = W5300_mac(6)

   If Dhcp_status = Dhcp_status_init Then
       Incr Lw : Dhcp_msg(lw) = Dhcp_opt_requested_ip_address                   'offered IP, dont use it until ACK is received
       Incr Lw : Dhcp_msg(lw) = &H04
       Incr Lw : Dhcp_msg(lw) = Dhcp_b_offer_ip(1)
       Incr Lw : Dhcp_msg(lw) = Dhcp_b_offer_ip(2)
       Incr Lw : Dhcp_msg(lw) = Dhcp_b_offer_ip(3)
       Incr Lw : Dhcp_msg(lw) = Dhcp_b_offer_ip(4)

       Incr Lw : Dhcp_msg(lw) = Dhcp_opt_server_identifier
       Incr Lw : Dhcp_msg(lw) = &H04
       Incr Lw : Dhcp_msg(lw) = Dhcp_b_dhcp_ip(1)
       Incr Lw : Dhcp_msg(lw) = Dhcp_b_dhcp_ip(2)
       Incr Lw : Dhcp_msg(lw) = Dhcp_b_dhcp_ip(3)
       Incr Lw : Dhcp_msg(lw) = Dhcp_b_dhcp_ip(4)
   Else
       Incr Lw : Dhcp_msg(lw) = Dhcp_opt_requested_ip_address
       Incr Lw : Dhcp_msg(lw) = &H04
       Incr Lw : Dhcp_msg(lw) = W5300_ip(1)
       Incr Lw : Dhcp_msg(lw) = W5300_ip(2)
       Incr Lw : Dhcp_msg(lw) = W5300_ip(3)
       Incr Lw : Dhcp_msg(lw) = W5300_ip(4)
   End If

'Hostame
   Incr Lw : Dhcp_msg(lw) = Dhcp_opt_hostname                                   'set Hostname
   L2 = Len(wiz_hostname)
   Incr Lw : Dhcp_msg(lw) = L2                                                  'length of Option
   For Li = 1 To L2
      Ls = Mid(wiz_hostname , Li , 1)
      Incr Lw : Dhcp_msg(lw) = Asc(ls)
   Next Li

'Options
   Incr Lw : Dhcp_msg(lw) = Dhcp_opt_parameter_request_list                     'request for...
   Incr Lw : L2 = Lw
   Incr Lw : Dhcp_msg(lw) = Dhcp_opt_subnetmask                                 'subnetmask
   Incr Lw : Dhcp_msg(lw) = Dhcp_opt_routersonsubnet
   Incr Lw : Dhcp_msg(lw) = Dhcp_opt_dns                                        'dns
   Incr Lw : Dhcp_msg(lw) = Dhcp_opt_hostname                                   'hostname
   Incr Lw : Dhcp_msg(lw) = Dhcp_opt_nameserver                                 'dns
   Incr Lw : Dhcp_msg(lw) = Dhcp_opt_ntp_server                                 'ntp server
   L1 = Lw - L2 : Dhcp_msg(l2) = L1                                             'Size of Options

   Dhcp_l_transaction_id = Dhcp_transaction_id
   Incr Lw : Dhcp_msg(lw) = Dhcp_endoption

'fill up to 548 Bytes BootStarpSize
'   For I = Lw To 548
'     Incr Lw : Dhcp_msg(lw) = 0
'   Next

   ' open socket
   Call Socket_open(socket_number , Sn_mr_udp , Udp_port_dhcp_local , Udp_port_dhcp_remote , W5300_dest_ip(1) , 0 )

   ' copy buf into tx fifo
   Call Udp_write_databuf(socket_number , Lw)
   ' updata txbuf pointer, send data
   Wiz_stack_timeout(socket_number) = Wiz_stack_timeout_value
   ' updata txbuf pointer, send data
   Call Wiz_write_socket(socket_number , W5300_s0_cr1 , Sn_cr_send)
End Sub

'-------------------------------------------------------------------------------
'  DHCP Acknowledgement received
'-------------------------------------------------------------------------------
Sub Dhcp_received_ack
   #if Debug_dhcp > 0
       Print #1 , "DHCP Ack received from IP "
   #endif

   'received ip lease --> my IP
   'Set Ip adress
   Call Wiz_set_network(3 , Dhcp_b_yiaddr(1))

   #if Debug_dhcp > 1
       Print #1 , "DHCP-Ack: IP-Address now: " ; Dhcp_b_yiaddr(1) ; "." ; Dhcp_b_yiaddr(2) ; "." ; Dhcp_b_yiaddr(3) ; "." ; Dhcp_b_yiaddr(4)
   #endif

   Call Dhcp_parse_options
   'set new network params
   'Call Wiz_network_param
   Dhcp_status = Dhcp_status_bound
   'reset already used transaction id
   Dhcp_transaction_id = 0

   #if Debug_dhcp > 1
       Print #1 , "DHCP Status changed to BOUND"
   #endif
End Sub

'-------------------------------------------------------------------------------
'  DHCP Negative Acknowledgement received
'-------------------------------------------------------------------------------
Sub Dhcp_received_nak
   #if Debug_dhcp > 0
       Print #1 , "DHCP Nak received from IP "
       Print #1 , "DHCP Status set to INIT"
   #endif
   Dhcp_status = Dhcp_status_init
End Sub

'-------------------------------------------------------------------------------
'  DHCP find option
'-------------------------------------------------------------------------------
Function Dhcp_find_option(byval Opt As Byte) As Word
Local Lw As Word
Local Lx As Word
   Lw = Dhcp_options_start
   Do
      Select Case Dhcp_msg(lw)
         Case 0                                                                 'Padding
            Incr Lw
         Case Opt
            Dhcp_find_option = Lw
            Exit Sub
         Case &HFF                                                              'End of Options
            Dhcp_find_option = 0
            Exit Sub
         Case Else
            Lx = Dhcp_msg(lw + 1)
            Lw = Lw + 2
            Lw = Lw + Lx
      End Select
   Loop
End Function




'-------------------------------------------------------------------------------
'  DHCP parse options
'-------------------------------------------------------------------------------
Sub Dhcp_parse_options
    Local Lw As Word
    Local Llen As Word
    Local Lo As Byte
    Local Ntp_temp As Byte
   Lw = Dhcp_options_start
   'reset NTP. If DHCP is transmiting a NTP Server, it will be set again
   Ntp_temp = 0
   Do
      Llen = Dhcp_msg(lw + 1)
      Lo = Dhcp_msg(lw)
      Select Case Dhcp_msg(lw)
         Case 0                                                                 'Padding
            Incr Lw
         Case Dhcp_opt_subnetmask                                               'Subnet Mask
            If Llen = 4 Then
               'Set Mask
               Call Wiz_set_network(2 , Dhcp_msg(lw + 2))
            End If
         Case Dhcp_opt_routersonsubnet                                          'Routers
            If Llen >= 4 Then
               'Set gateway adress
               Call Wiz_set_network(1 , Dhcp_msg(lw + 2))
               #if Debug_dhcp > 1
                  Print #1 , "DHCP-Ack: Default GW now: " ; Wiz_read(w5300_gar0) ; "." ; Wiz_read(w5300_gar1) ; "." ; Wiz_read(w5300_gar2) ; "." ; Wiz_read(w5300_gar3)
               #endif
            End If
         Case Dhcp_opt_ntp_server                                               'Time Servers
            If Llen >= 4 Then
               Ntp_temp = 1
               If Ntp_stat_on = 0 Then
                 Call Wiz_set_network(5 , Dhcp_msg(lw + 2))
                 #if Debug_dhcp > 1
                    Print #1 , "DHCP-Ack: NTP server now: " ; W5300_time_server(1) ; "." ; W5300_time_server(2) ; "." ; W5300_time_server(3) ; "." ; W5300_time_server(4)
                 #endif
               End If
            End If
         Case Dhcp_opt_leasetime                                                'IP Address Lease Time
            If Llen = 4 Then
               Dhcp_lease_time = Bytes2long(dhcp_msg(lw + 5) , Dhcp_msg(lw + 4) , Dhcp_msg(lw + 3) , Dhcp_msg(lw + 2))
            End If
         Case Dhcp_opt_server_identifier                                        'DHCP Server Identification
            If Llen = 4 Then
               Call Wiz_set_network(6 , Dhcp_msg(lw + 2))
               #if Debug_dhcp > 1
                  Print #1 , "DHCP-Ack: DHCP Server now: " ; Dhcp_b_recent_server_ip(1) ; "." ; Dhcp_b_recent_server_ip(2) ; "." ; Dhcp_b_recent_server_ip(3) ; "." ; Dhcp_b_recent_server_ip(4)
               #endif
            End If
         Case Dhcp_opt_renewal                                                  'Renewal (T1) Time Value
            If Llen = 4 Then
               Dhcp_renew_time = Bytes2long(dhcp_msg(lw + 5) , Dhcp_msg(lw + 4) , Dhcp_msg(lw + 3) , Dhcp_msg(lw + 2))
            End If
         Case Dhcp_opt_rebinding                                                'Rebinding (T2) Time Value
            If Llen = 4 Then
               Dhcp_rebinding_time = Bytes2long(dhcp_msg(lw + 5) , Dhcp_msg(lw + 4) , Dhcp_msg(lw + 3) , Dhcp_msg(lw + 2))
            End If
         Case &HFF                                                              'End of Options
            Exit Sub
         Case Else
               #if Debug_dhcp > 1
                  Print #1 , "DHCP-Ack: DHCP Opt: $" ; Hex(dhcp_msg(lw))
               #endif
      End Select
      If Dhcp_msg(lw) > 0 Then
         Lw = Lw + 2
         Lw = Lw + Llen
      End If
   Loop
   If Ntp_on = 1 And Ntp_temp = 0 Then
      Ntp_on = 0
   End If
End Sub

'-------------------------------------------------------------------------------
'  DHCP create new transaction ID
'-------------------------------------------------------------------------------
Sub Dhcp_create_new_xid
Local Lw As Word
   Dhcp_transaction_id = Rnd(&Hffff)
   Shift Dhcp_transaction_id , Left , 16
   Lw = Rnd(&Hffff)
   Dhcp_transaction_id = Dhcp_transaction_id + Lw
End Sub