'*******************************************************************************
'
'  Copyright Michael Koecher aka six1 8/2010
'  -> http://www.six1.net/   michael@koecher-web.de
'
'   http://creativecommons.org/licenses/by-sa/3.0/de/
'
'   Sie drfen:
'
'     * das Werk bzw. den Inhalt vervielfltigen, verbreiten und ffentlich zugnglich machen
'
'     * Abwandlungen und Bearbeitungen des Werkes bzw. Inhaltes anfertigen
'
'   Zu Den Folgenden Bedingungen:
'
'     * Namensnennung.
'       Sie mssen den Namen des Autors/Rechteinhabers in der von ihm festgelegten Weise nennen.
'
'     * Keine kommerzielle Nutzung.
'       Dieses Werk darf nicht fr kommerzielle Zwecke verwendet werden.
'
'     * Weitergabe unter gleichen Bedingungen.
'       Wenn Sie das lizenzierte Werk bzw. den lizenzierten Inhalt bearbeiten
'       oder in anderer Weise erkennbar als Grundlage fr eigenes Schaffen verwenden,
'       drfen Sie die daraufhin neu entstandenen Werke bzw. Inhalte nur
'       unter Verwendung von Lizenzbedingungen weitergeben, die mit denen
'       dieses Lizenzvertrages identisch oder vergleichbar sind.
'
'   Wobei gilt:
'
'     * Verzichtserklrung
'       Jede der vorgenannten Bedingungen kann aufgehoben werden, sofern Sie
'       die ausdrckliche Einwilligung des Rechteinhabers dazu erhalten.
'
'     * Sonstige Rechte
'       Die Lizenz hat keinerlei Einfluss auf die folgenden Rechte:
'          - Die gesetzlichen Schranken des Urheberrechts und sonstigen
'            Befugnisse zur privaten Nutzung
'          - Das Urheberpersnlichkeitsrecht des Rechteinhabers
'          - Rechte anderer Personen, entweder am Lizenzgegenstand selber oder
'            bezglich seiner Verwendung, zum Beispiel Persnlichkeitsrechte abgebildeter Personen.
'
'  Hinweis
'
'      Im Falle einer Verbreitung mssen Sie anderen alle Lizenzbedingungen
'      mitteilen, die fr dieses Werk gelten. Am einfachsten ist es,
'      einen Link auf http://creativecommons.org/licenses/by-sa/3.0/de/ einzubinden.
'

'*******************************************************************************
$nocompile

' RFC 1305 NTP

'-------------------------------------------------------------------------------
' Udp_ntp get time from received packet
'-------------------------------------------------------------------------------
Sub Udp_ntp(byval Socket_number As Byte)
   Wiz_time = Ntp_b8_receive_timestamp(1)
   Shift Wiz_time , Left , 8
   Wiz_time = Wiz_time + Ntp_b8_receive_timestamp(2)
   Shift Wiz_time , Left , 8
   Wiz_time = Wiz_time + Ntp_b8_receive_timestamp(3)
   Shift Wiz_time , Left , 8
   Wiz_time = Wiz_time + Ntp_b8_receive_timestamp(4)

   Wiz_time = Wiz_time + Ntp_offset_to_bascom
   Wiz_time = Wiz_time + Ntp_one_hour_offset                                    ' offset UTC + 1 hour
   Call Ntp_dst_correction
   Call Socket_close(socket_number)
   'Update Time every hour
   Ntp_request_time = Wiz_time + 3600
End Sub


'-------------------------------------------------------------------------------
' Ntp_dst_correction correct date
'-------------------------------------------------------------------------------
Sub Ntp_dst_correction
   Local Second As Byte
   Local Minute As Byte
   Local Hour As Byte
   Local Day As Byte
   Local Month As Byte
   Local Year As Byte
   Local Dow As Byte

   Day = Date(wiz_time)
   Month = 4
   Day = 1
   Hour = 2
   Minute = 0
   Second = 0
   Dow = Dayofweek(day)
   Day = 31 - Dow
   Month = 3
   If Wiz_time >= Syssec(second) Then
       Day = 1
       Month = 11
       Dow = Dayofweek(day)
       Day = 31 - Dow
       Month = 10
       If Wiz_time < Syssec(second) Then
          Wiz_time = Wiz_time + Ntp_one_hour_offset
       End If
   End If

End Sub

'-------------------------------------------------------------------------------
' Start An Ntp Request
'-------------------------------------------------------------------------------
Sub Ntp_request(byval Socket_number As Byte)
Dim Xx As Byte
   If Socket_number = 0 Then Socket_number = Get_free_socket()
   If Socket_number = 0 Then
      Print #1 , "No free Socket for NTP!"
      Exit Sub
   End If

   For Xx = 1 To 48
     Ntp_msg(xx) = &H00
   Next

'(
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
      +    Byte 1     +    Byte 2     +    Byte 3     +    Byte 4     +
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
      |               |    1          |        2      |            3  |
       0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
1     |LI | VN  |Mode |    Stratum    |     Poll      |   Precision   |
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
2     |                          Root Delay                           |
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
3     |                       Root Dispersion                         |
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
4     |                    Reference Identifier                       |
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
5     |                    Reference Timestamp (64)                   |
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
6     |                    Reference Timestamp                        |
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
7     |                    Originate Timestamp (64)                   |
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
8     |                    Originate Timestamp                        |
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
9     |                     Receive Timestamp  (64)                   |
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
10    |                     Receive Timestamp                         |
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
11    |                    Transmit Timestamp  (64)                   |
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
12    |                    Transmit Timestamp                         |
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

      11011001
      LI        2 bit  01   +1 second (following minute has 61 seconds)
      VN        3 bit  110  Version 3
      mode      3 bit  110  Client 3
')

'NTP Frame
   'LI, VN, MODE
    Ntp_msg(1) = Ntp_flags_mode : Shift Ntp_msg(1) , Left , 3
    Ntp_msg(1) = Ntp_msg(1) Or Ntp_flags_version : Shift Ntp_msg(1) , Left , 3
    Ntp_msg(1) = Ntp_msg(1) Or Ntp_flags_leap_indicator
   'stratum  Ntp_msg(2)
   'poll     Ntp_msg(3)
   'Precision Ntp_msg(4)
    Ntp_msg(4) = &H01

   'Root Delay            Ntp_msg(5) - Ntp_msg(8)
   'Root Dispersion       Ntp_msg(9) - Ntp_msg(12)
   'Reference Identifier  Ntp_msg(13) - Ntp_msg(16)
   'Reference Timestamp   Ntp_msg(17) - Ntp_msg(24)
   'Originate Timestamp   Ntp_msg(25) - Ntp_msg(32)
   'Receive Timestamp     Ntp_msg(33) - Ntp_msg(40)
   'Transmit Timestamp    Ntp_msg(41) - Ntp_msg(48)

   Call Socket_open(socket_number , Sn_mr_udp , Udp_port_ntp_src , Udp_port_ntp_dst , W5300_time_server(1) , 0)

   ' updata txbuf pointer, send data
   Call Udp_write_databuf(socket_number , 48)

   ' updata txbuf pointer, send data
   Call Wiz_write_socket(socket_number , W5300_s0_cr1 , Sn_cr_send)
   Wiz_stack_timeout(socket_number) = Wiz_stack_timeout_value
End Sub