'*******************************************************************************
'
'  Copyright Michael Koecher aka six1 8/2010
'  -> http://www.six1.net/   michael@koecher-web.de
'
'   http://creativecommons.org/licenses/by-sa/3.0/de/
'
'   Sie drfen:
'
'     * das Werk bzw. den Inhalt vervielfltigen, verbreiten und ffentlich zugnglich machen
'
'     * Abwandlungen und Bearbeitungen des Werkes bzw. Inhaltes anfertigen
'
'   Zu Den Folgenden Bedingungen:
'
'     * Namensnennung.
'       Sie mssen den Namen des Autors/Rechteinhabers in der von ihm festgelegten Weise nennen.
'
'     * Keine kommerzielle Nutzung.
'       Dieses Werk darf nicht fr kommerzielle Zwecke verwendet werden.
'
'     * Weitergabe unter gleichen Bedingungen.
'       Wenn Sie das lizenzierte Werk bzw. den lizenzierten Inhalt bearbeiten
'       oder in anderer Weise erkennbar als Grundlage fr eigenes Schaffen verwenden,
'       drfen Sie die daraufhin neu entstandenen Werke bzw. Inhalte nur
'       unter Verwendung von Lizenzbedingungen weitergeben, die mit denen
'       dieses Lizenzvertrages identisch oder vergleichbar sind.
'
'   Wobei gilt:
'
'     * Verzichtserklrung
'       Jede der vorgenannten Bedingungen kann aufgehoben werden, sofern Sie
'       die ausdrckliche Einwilligung des Rechteinhabers dazu erhalten.
'
'     * Sonstige Rechte
'       Die Lizenz hat keinerlei Einfluss auf die folgenden Rechte:
'          - Die gesetzlichen Schranken des Urheberrechts und sonstigen
'            Befugnisse zur privaten Nutzung
'          - Das Urheberpersnlichkeitsrecht des Rechteinhabers
'          - Rechte anderer Personen, entweder am Lizenzgegenstand selber oder
'            bezglich seiner Verwendung, zum Beispiel Persnlichkeitsrechte abgebildeter Personen.
'
'  Hinweis
'
'      Im Falle einer Verbreitung mssen Sie anderen alle Lizenzbedingungen
'      mitteilen, die fr dieses Werk gelten. Am einfachsten ist es,
'      einen Link auf http://creativecommons.org/licenses/by-sa/3.0/de/ einzubinden.
'

'*******************************************************************************
$nocompile

'-------------------------------------------------------------------------------
' Wiz_udp Switch Function According To The Port
'-------------------------------------------------------------------------------
Sub Wiz_udp(byval Socket_number As Byte)
    Local B_b As Byte
    Call Udp_read_paket_header(socket_number)
    Call Udp_read_databuf(socket_number , Udp_header_payload_len)
   #if Udp_debug > 0
      Print #1 , "Src IP  : " ; Str(udp_header_ip(1)) + "." ; Str(udp_header_ip(2)) + "." ; Str(udp_header_ip(3)) + "." ; Str(udp_header_ip(4))
      Print #1 , "Src Port: " ; Udp_port_src
      Print #1 , "Dst Port: " ; Udp_header_port
      Print #1 , "Pkt.len.: " ; Udp_header_payload_len
   #endif
    Call Wiz_write_socket(socket_number , W5300_s0_ir1 , $ff)
    Select Case Udp_port_src
      #if Ntp_dhcp_dns > 0
      Case Udp_port_ntp_src : Call Udp_ntp(socket_number)
      Case Udp_port_dhcp_local : Call Dhcp_packet_filter(socket_number)
      #endif
      Case Udp_port_wiz_remote : Call Udp_remote(socket_number)
    End Select
End Sub

'-------------------------------------------------------------------------------
' Udp_read_databuf read data from w5300 fifo into udp buff
'-------------------------------------------------------------------------------
Sub Udp_read_databuf(byval Socket_number As Byte , Byval Data_len As Word )
   Local Pos As Word , Y As Word
   Pos = 1
   If Data_len.0 = 1 Then Incr Data_len
   For Y = 2 To Data_len Step 2
      Udp_payload(pos) = Wiz_read_socket(socket_number , W5300_s0_rx_fifor0) : Incr Pos
      Udp_payload(pos) = Wiz_read_socket(socket_number , W5300_s0_rx_fifor1) : Incr Pos
   Next
  ' Call Wiz_write_socket(socket_number , W5300_s0_cr1 , Sn_cr_recv)
End Sub

'-------------------------------------------------------------------------------
' Udp_write_databuf write data to w5300 fifo
'-------------------------------------------------------------------------------
Sub Udp_write_databuf(byval Socket_number As Byte , Byval Data_len As Word)
   Local Max_buffer_size As Word
   Local D As Word
   Local Add_address As Word , Address As Word
   Local Fifo0_addr As Word
   Local Fifo1_addr As Word

   'calculate Socket Address
   Add_address = Socket_number
   Decr Add_address
   Add_address = Add_address * Socket_reg_size
   Fifo0_addr = Add_address + W5300_s0_tx_fifor0
   Fifo1_addr = Add_address + W5300_s0_tx_fifor1
   Max_buffer_size = Get_tx_size(socket_number)
   If Data_len > Max_buffer_size Then
      Data_len = Max_buffer_size
   End If
   Adres16 = Data_len
   If Data_len.0 = 1 Then Incr Data_len
   For D = 1 To Data_len Step 2
     Out Fifo0_addr , Udp_payload(d)                        'High adress
     Out Fifo1_addr , Udp_payload(d + 1)                    'low  adress
   Next
   ' Set Write Size Register
   Call Wiz_write_socket(socket_number , W5300_s0_tx_wrsr0 , &H0)
   Call Wiz_write_socket(socket_number , W5300_s0_tx_wrsr1 , &H0)
   Call Wiz_write_socket(socket_number , W5300_s0_tx_wrsr2 , Adres16_h)
   Call Wiz_write_socket(socket_number , W5300_s0_tx_wrsr3 , Adres16_l)
End Sub

'-------------------------------------------------------------------------------
'  Check_udp_remote_config_sock  checks for open Sock
'-------------------------------------------------------------------------------
Sub Check_udp_remote_config_sock(byval Socket_number As Byte)
  #if Remote_sock > 0
    If Get_socket_status(socket_number) = Sock_closed Then
       Call Socket_open(socket_number , Sn_mr_udp , Udp_port_wiz_remote , 0 , Udp_broadcast_ip(1) , 0)
    End If
    If Wiz_stack_timeout(socket_number) <= 2 Then
       Wiz_stack_timeout(socket_number) = Wiz_stack_timeout_value
    End If
  #endif
End Sub



'-------------------------------------------------------------------------------
'  UDP Remote for WIZ200
'-------------------------------------------------------------------------------
Sub Udp_remote(byval Socket_number As Byte)
   Local Size As Word , Char As String * 1 , S_s As String * 20
   Local Command As Byte , Data_startpos As Byte , X As Word , Esf_pos As Word , Checksumme As Word
   Local Block_check As Word , Block_check_rx As Word , Tmp_check As Word
   Local B_b As Byte , Finished As Byte

   #if Udp_debug > 0
     Print
     Print #1 , "=============================="
     Print #1 , "  UDP Remote Packet received "
     Print #1 , "------------------------------"
   #endif
   Finished = 0
   Size = 0
   S_s = ""
   X = 1
   Do
     S_s = S_s + Chr(udp_payload(x))
     Incr X
   Loop Until X = 20 Or Udp_payload(x) = 0

   If S_s = "{NEWSYSTEM}" Then
     'following 3 bytes = System size
     Esfsystemsize = 0
     Esfsystemsize = Udp_payload(13)
     Shift Esfsystemsize , Left , 8
     Esfsystemsize = Esfsystemsize + Udp_payload(14)
     Shift Esfsystemsize , Left , 8
     Esfsystemsize = Esfsystemsize + Udp_payload(15)
     Print #1 , "RX ESF Data. Now loading " ; Esfsystemsize ; " Byte..."
     New_system_status = 1
     Esfsystemcount = 0
     Pagecounter = 0
     Esf_pos = 0
     Checksum_rx = 0

   Elseif S_s = "{SYSBLOCK}" Or S_s = "{FILBLOCK}" Then
    Esfblockcount = 0
    Esf_pos = 0
    Esfblockcount = Udp_payload(12)
    Shift Esfblockcount , Left , 8
    Esfblockcount = Esfblockcount + Udp_payload(13)
    Block_check = 0
    Block_check_rx = Udp_payload(14)
    Shift Block_check_rx , Left , 8
    Block_check_rx = Block_check_rx + Udp_payload(15)
    Tmp_check = 0
    For X = 16 To Udp_header_payload_len
       Call Df_bufferwritebyte(1 , Esf_pos , Udp_payload(x))
       If Esfsystemcount < Esfsystemsize Then
          Checksum_rx = Checksum_rx + Udp_payload(x)
          Block_check = Block_check + Udp_payload(x)
       End If
       Incr Esf_pos
       Incr Esfsystemcount
    Next
    #if Udp_debug = 1
       Print #1 , S_s ; Esfblockcount ; " Byte count: " ; Esfsystemcount ; " Block_check: $" ; Hex(block_check) ; " rx: $" ; Hex(block_check_rx)
    #endif
    If Block_check <> Block_check_rx Then
      Print #1 , "Block " ; Esfblockcount ; " CRC Error"
      ' get previous block
      X = Udp_header_payload_len - 16
      Esfsystemcount = Esfsystemcount - X
      Decr Esfsystemcount
      Decr Esfblockcount
      Size = 1
      Udp_payload(size) = Asc( "{") : Incr Size
      Udp_payload(size) = 255 : Incr Size
      Udp_payload(size) = Asc( "}") : Incr Size
      Udp_payload(size) = High(esfblockcount) : Incr Size
      Udp_payload(size) = Low(esfblockcount) : Incr Size
      If S_s = "{FILBLOCK}" Then
        Call Df_bufferwritebyte(1 , 0 , 0)
        Call Df_buffertopage(1 , 513)
      End If
    Else
      Call Df_buffertopage(1 , Esfblockcount)

      If Esfsystemcount >= Esfsystemsize Then
        Checksumme = Udp_payload(udp_header_payload_len - 1)
        Shift Checksumme , Left , 8
        Checksumme = Checksumme + Udp_payload(udp_header_payload_len)

        If Checksumme = Checksum_rx Then
           New_system_status = 0
           If S_s = "{SYSBLOCK}" Then
Print #1 , "Set System as valid and reboot..."
             'System in ESF is ok!
             Call Df_bufferwritebyte(1 , 0 , 1)
             '255 Byte blocks total
             B_b = High(esfblockcount)
             Call Df_bufferwritebyte(1 , 1 , B_b)
             B_b = Low(esfblockcount)
             Call Df_bufferwritebyte(1 , 2 , B_b)
             Call Df_buffertopage(1 , 2047)
           End If
            ' send last ACk for last block
           Size = 1
           Udp_payload(size) = Asc( "{") : Incr Size
           Udp_payload(size) = 255 : Incr Size
           Udp_payload(size) = Asc( "}") : Incr Size
           Udp_payload(size) = High(esfblockcount) : Incr Size
           Udp_payload(size) = Low(esfblockcount) : Incr Size
Dhcp_on = &HFF
Ntp_on = 0
           'Watchdog Reset
           Finished = 1
        Else
          Print #1 , "Error! Checksum got: " ; Checksum_rx ; "Checksum calc: " ; Checksumme
           'stop it
           New_system_status = 0
        End If
      Else
        Size = 1
        Udp_payload(size) = Asc( "{") : Incr Size
        Udp_payload(size) = 255 : Incr Size
        Udp_payload(size) = Asc( "}") : Incr Size
        Udp_payload(size) = High(esfblockcount) : Incr Size
        Udp_payload(size) = Low(esfblockcount) : Incr Size
      End If
    End If
   Else
     'extract command
    New_system_status = 0
    Command = 0
    If Udp_payload(1) = 123 And Udp_payload(3) = 125 Then
       Command = Udp_payload(2)
    End If
   Select Case Command
     '*** SET PARAM ***
     'DHCP ON/OFF
     Case 1 :
               If Udp_payload(4) = 0 Then
                  Dhcp_on = 0
                  Call Wiz_set_network(3 , W5300_ip(1))
                  W5300_time_server(1) = Ee_time(1)
                  W5300_time_server(2) = Ee_time(2)
                  W5300_time_server(3) = Ee_time(3)
                  W5300_time_server(4) = Ee_time(4)
               Else
                  If Dhcp_on <> 1 Then
                    Dhcp_on = 1                             'Start DHCP
                    Dhcp_b_yiaddr(1) = 0
                    Dhcp_b_yiaddr(2) = 0
                    Dhcp_b_yiaddr(3) = 0
                    Dhcp_b_yiaddr(4) = 0
                    Dhcp_renew_time = 0
                    Dhcp_rebinding_time = 0
                    Dhcp_lease_time = 0
                    Dhcp_request_time = 0
                    Dhcp_status = Dhcp_status_init
                  End If
               End If
               Ee_dhcp = Dhcp_on
     'NTP ON/OFF
     Case 2 :
               If Udp_payload(4) = 0 Then
                  Ntp_on = 0
               Else
                  Ntp_on = 1
               End If
               Ee_ntp = Ntp_on
     'NTP stat ON/OFF
     Case 16 :
               If Udp_payload(4) = 0 Then
                  Ntp_stat_on = 0
               Else
                  Ntp_stat_on = 1
               End If
               Ee_ntp_stat = Ntp_stat_on
     'Hostname
     Case 3 :
               X = 4
               Wiz_hostname = ""
               For X = 4 To 15
                  If Udp_payload(x) = 0 Then
                    Exit For
                  End If
                  Wiz_hostname = Wiz_hostname + Chr(udp_payload(x))
               Next
               Ee_hostname = Wiz_hostname
     'Set gateway adress
     Case 10 :
                W5300_gw(1) = Udp_payload(4)
                W5300_gw(2) = Udp_payload(5)
                W5300_gw(3) = Udp_payload(6)
                W5300_gw(4) = Udp_payload(7)
                Call Wiz_set_network(1 , W5300_gw(1))
                Ee_gw(1) = W5300_gw(1) : Ee_gw(2) = W5300_gw(2) : Ee_gw(3) = W5300_gw(3) : Ee_gw(4) = W5300_gw(4)
     'Set Mask
     Case 11 : W5300_mask(1) = Udp_payload(4)
                W5300_mask(2) = Udp_payload(5)
                W5300_mask(3) = Udp_payload(6)
                W5300_mask(4) = Udp_payload(7)
                Call Wiz_set_network(2 , W5300_mask(1))
                Ee_mask(1) = W5300_mask(1) : Ee_mask(2) = W5300_mask(2) : Ee_mask(3) = W5300_mask(3) : Ee_mask(4) = W5300_mask(4)
    'Set stat Ip adress
     Case 12 :
                W5300_ip(1) = Udp_payload(4)
                W5300_ip(2) = Udp_payload(5)
                W5300_ip(3) = Udp_payload(6)
                W5300_ip(4) = Udp_payload(7)
                ' set ip only active, if no DHCP is running!
                If Dhcp_status <> Dhcp_status_bound Then
                   Call Wiz_set_network(3 , W5300_ip(1))
                End If
                Ee_ip(1) = W5300_ip(1) : Ee_ip(2) = W5300_ip(2) : Ee_ip(3) = W5300_ip(3) : Ee_ip(4) = W5300_ip(4)
     'Set MAC Server
     Case 13 :
                W5300_mac(1) = Udp_payload(4)
                W5300_mac(2) = Udp_payload(5)
                W5300_mac(3) = Udp_payload(6)
                W5300_mac(4) = Udp_payload(7)
                W5300_mac(5) = Udp_payload(8)
                W5300_mac(6) = Udp_payload(9)

                Ee_mac(1) = W5300_mac(1) : Ee_mac(2) = W5300_mac(2) : Ee_mac(3) = W5300_mac(3) : Ee_mac(4) = W5300_mac(4) : Ee_mac(5) = W5300_mac(5) : Ee_mac(6) = W5300_mac(6)
     'Set NTP Server
     Case 14 :
                W5300_time_server(1) = Udp_payload(4)
                W5300_time_server(2) = Udp_payload(5)
                W5300_time_server(3) = Udp_payload(6)
                W5300_time_server(4) = Udp_payload(7)
                Ee_time(1) = W5300_time_server(1) : Ee_time(2) = W5300_time_server(2) : Ee_time(3) = W5300_time_server(3) : Ee_time(4) = W5300_time_server(4)



   #if Smtp_sock > 0
     'Set eMail Name
     Case 20 :
               X = 4
               Email_address = ""
               For X = 4 To 34
                  If Udp_payload(x) = 0 Then
                    Exit For
                  End If
                  Email_address = Email_address + Chr(udp_payload(x))
               Next
               Ee_email_address = Email_address
     'Set eMail Pass
     Case 21 :
               X = 4
               Email_pass = ""
               For X = 4 To 19
                  If Udp_payload(x) = 0 Then
                    Exit For
                  End If
                  Email_pass = Email_pass + Chr(udp_payload(x))
               Next
               Ee_email_pass = Email_pass
     'Set eMail Domain
     Case 22 :
               X = 4
               Email_smtp = ""
               For X = 4 To 24
                  If Udp_payload(x) = 0 Then
                    Exit For
                  End If
                  Email_smtp = Email_smtp + Chr(udp_payload(x))
               Next
               Ee_email_smtp = Email_smtp
     'Set eMail SMTP
     Case 23 :
               X = 4
               Email_recipient = ""
               For X = 4 To 34
                  If Udp_payload(x) = 0 Then
                    Exit For
                  End If
                  Email_recipient = Email_recipient + Chr(udp_payload(x))
               Next
               Ee_email_recipient = Email_recipient
   #endif
     '*** GET PARAM ***
     'DHCP ON/OFF
     Case 101 : Size = 1
                Udp_payload(size) = Asc( "{") : Incr Size
                Udp_payload(size) = 1 : Incr Size
                Udp_payload(size) = Asc( "}") : Incr Size
                Udp_payload(size) = Dhcp_on
     'NTP ON/OFF
     Case 102 : Size = 1
                Udp_payload(size) = Asc( "{") : Incr Size
                Udp_payload(size) = 2 : Incr Size
                Udp_payload(size) = Asc( "}") : Incr Size
                Udp_payload(size) = Ntp_on
     'NTP stat ON/OFF
     Case 116 : Size = 1
                Udp_payload(size) = Asc( "{") : Incr Size
                Udp_payload(size) = 16 : Incr Size
                Udp_payload(size) = Asc( "}") : Incr Size
                Udp_payload(size) = Ntp_stat_on
     'Hostname
     Case 103 : Size = 1
                Udp_payload(size) = Asc( "{") : Incr Size
                Udp_payload(size) = 3 : Incr Size
                Udp_payload(size) = Asc( "}") : Incr Size
                For X = 1 To Len(wiz_hostname)
                   Char = Mid(wiz_hostname , X , 1)
                   Udp_payload(size) = Asc(char)
                   Incr Size
                Next
                Udp_payload(size) = 0
     'Get gateway adress
     Case 110 : Size = 1
                Udp_payload(size) = Asc( "{") : Incr Size
                Udp_payload(size) = 10 : Incr Size
                Udp_payload(size) = Asc( "}") : Incr Size
                Udp_payload(size) = Wiz_read(w5300_gar0) : Incr Size
                Udp_payload(size) = Wiz_read(w5300_gar1) : Incr Size
                Udp_payload(size) = Wiz_read(w5300_gar2) : Incr Size
                Udp_payload(size) = Wiz_read(w5300_gar3)
     'Get Mask
     Case 111 : Size = 1
                Udp_payload(size) = Asc( "{") : Incr Size
                Udp_payload(size) = 11 : Incr Size
                Udp_payload(size) = Asc( "}") : Incr Size
                Udp_payload(size) = Wiz_read(w5300_subr0) : Incr Size
                Udp_payload(size) = Wiz_read(w5300_subr1) : Incr Size
                Udp_payload(size) = Wiz_read(w5300_subr2) : Incr Size
                Udp_payload(size) = Wiz_read(w5300_subr3)
     'Get STAT Ip adress
     Case 112 : Size = 1
                Udp_payload(size) = Asc( "{") : Incr Size
                Udp_payload(size) = 12 : Incr Size
                Udp_payload(size) = Asc( "}") : Incr Size
                Udp_payload(size) = W5300_ip(1) : Incr Size
                Udp_payload(size) = W5300_ip(2) : Incr Size
                Udp_payload(size) = W5300_ip(3) : Incr Size
                Udp_payload(size) = W5300_ip(4)
     'Get DYN Ip adress
     Case 115 : Size = 1
                Udp_payload(size) = Asc( "{") : Incr Size
                Udp_payload(size) = 15 : Incr Size
                Udp_payload(size) = Asc( "}") : Incr Size
                If Dhcp_on = 1 Then
                  Udp_payload(size) = Wiz_read(w5300_sipr0) : Incr Size
                  Udp_payload(size) = Wiz_read(w5300_sipr1) : Incr Size
                  Udp_payload(size) = Wiz_read(w5300_sipr2) : Incr Size
                  Udp_payload(size) = Wiz_read(w5300_sipr3)
                Else
                  Udp_payload(size) = 0 : Incr Size
                  Udp_payload(size) = 0 : Incr Size
                  Udp_payload(size) = 0 : Incr Size
                  Udp_payload(size) = 0
                End If
     'Get MAC
     Case 113 : Size = 1
                Udp_payload(size) = Asc( "{") : Incr Size
                Udp_payload(size) = 13 : Incr Size
                Udp_payload(size) = Asc( "}") : Incr Size
                Udp_payload(size) = W5300_mac(1) : Incr Size
                Udp_payload(size) = W5300_mac(2) : Incr Size
                Udp_payload(size) = W5300_mac(3) : Incr Size
                Udp_payload(size) = W5300_mac(4) : Incr Size
                Udp_payload(size) = W5300_mac(5) : Incr Size
                Udp_payload(size) = W5300_mac(6)
     'Get NTP adress
     Case 114 : Size = 1
                Udp_payload(size) = Asc( "{") : Incr Size
                Udp_payload(size) = 14 : Incr Size
                Udp_payload(size) = Asc( "}") : Incr Size
                Udp_payload(size) = W5300_time_server(1) : Incr Size
                Udp_payload(size) = W5300_time_server(2) : Incr Size
                Udp_payload(size) = W5300_time_server(3) : Incr Size
                Udp_payload(size) = W5300_time_server(4)


   #if Smtp_sock > 0
     ' Get eMail Name
     Case 120 : Size = 1
                Udp_payload(size) = Asc( "{") : Incr Size
                Udp_payload(size) = 20 : Incr Size
                Udp_payload(size) = Asc( "}") : Incr Size
                For X = 1 To Len(email_address)
                   Char = Mid(email_address , X , 1)
                   Udp_payload(size) = Asc(char)
                   Incr Size
                Next
                Udp_payload(size) = 0
     ' Get eMail Pass
     Case 121 : Size = 1
                Udp_payload(size) = Asc( "{") : Incr Size
                Udp_payload(size) = 21 : Incr Size
                Udp_payload(size) = Asc( "}") : Incr Size
                For X = 1 To Len(email_pass)
                   Char = Mid(email_pass , X , 1)
                   Udp_payload(size) = Asc(char)
                   Incr Size
                Next
                Udp_payload(size) = 0
     ' Get eMail SMTP
     Case 122 : Size = 1
                Udp_payload(size) = Asc( "{") : Incr Size
                Udp_payload(size) = 22 : Incr Size
                Udp_payload(size) = Asc( "}") : Incr Size
                For X = 1 To Len(email_smtp)
                   Char = Mid(email_smtp , X , 1)
                   Udp_payload(size) = Asc(char)
                   Incr Size
                Next
                Udp_payload(size) = 0
     ' Get eMail Recipient
     Case 123 : Size = 1
                Udp_payload(size) = Asc( "{") : Incr Size
                Udp_payload(size) = 23 : Incr Size
                Udp_payload(size) = Asc( "}") : Incr Size
                For X = 1 To Len(email_recipient)
                   Char = Mid(email_recipient , X , 1)
                   Udp_payload(size) = Asc(char)
                   Incr Size
                Next
                Udp_payload(size) = 0
   #endif
     'Get attention
     Case 200 : Size = 1
                S_s = "{" + Chr(200) + "}WIZ200 alive"
                For X = 1 To Len(s_s)
                   Char = Mid(s_s , X , 1)
                   Udp_payload(size) = Asc(char)
                   Incr Size
                Next
                Decr Size
     End Select
  End If

   If Size > 0 Then
      Call Wiz_write_socket(socket_number , W5300_s0_cr1 , Sn_cr_discon)
      Call Socket_open(socket_number , Sn_mr_udp , Udp_port_wiz_remote , Udp_header_port , Udp_header_ip(1) , 0)
      ' copy buf into tx fifo
      Call Udp_write_databuf(socket_number , Size)
      ' updata txbuf pointer, send data
      Call Wiz_write_socket(socket_number , W5300_s0_cr1 , Sn_cr_send)
   End If

   If Finished = 1 Then
      'wait for Watchdog Reset
      Do
        !nop
      Loop
   End If
End Sub

'-------------------------------------------------------------------------------
'Read Rx Data To Buffer
'-------------------------------------------------------------------------------
Sub Udp_read_paket_header(byval Socket_number As Byte)
   'Read 8 bytes head information
   'Dest IP
   Udp_header_ip(1) = Wiz_read_socket(socket_number , W5300_s0_rx_fifor0)
   Udp_header_ip(2) = Wiz_read_socket(socket_number , W5300_s0_rx_fifor1)

   Udp_header_ip(3) = Wiz_read_socket(socket_number , W5300_s0_rx_fifor0)
   Udp_header_ip(4) = Wiz_read_socket(socket_number , W5300_s0_rx_fifor1)

   'dest Port
   Udp_header_port_h = Wiz_read_socket(socket_number , W5300_s0_rx_fifor0)
   Udp_header_port_l = Wiz_read_socket(socket_number , W5300_s0_rx_fifor1)

   'length of rx data
   Udp_header_payload_len_h = Wiz_read_socket(socket_number , W5300_s0_rx_fifor0)
   Udp_header_payload_len_l = Wiz_read_socket(socket_number , W5300_s0_rx_fifor1)

    Udp_port_src_h = Wiz_read_socket(socket_number , W5300_s0_portr0)
    Udp_port_src_l = Wiz_read_socket(socket_number , W5300_s0_portr1)
    Udp_port_dst_h = Wiz_read_socket(socket_number , W5300_s0_dportr0)
    Udp_port_dst_l = Wiz_read_socket(socket_number , W5300_s0_dportr1)

End Sub